/*     */ package com.netapp.asup.client.helper;
/*     */ 
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.UnsupportedEncodingException;
/*     */ import java.net.URLEncoder;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import javax.xml.stream.FactoryConfigurationError;
/*     */ import javax.xml.stream.XMLOutputFactory;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.XMLStreamWriter;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class XMLHelper
/*     */ {
/*     */   public static XMLStreamWriter initializeXmlWriter(ByteArrayOutputStream outStream)
/*     */     throws FactoryConfigurationError, XMLStreamException
/*     */   {
/*  22 */     XMLOutputFactory factory = XMLOutputFactory.newInstance();
/*  23 */     XMLStreamWriter writer = factory.createXMLStreamWriter(outStream, "UTF-8");
/*     */     
/*  25 */     writer.writeStartElement("xml");
/*     */     
/*  27 */     return writer;
/*     */   }
/*     */   
/*     */   public static void closeXmlWriter(XMLStreamWriter writer) throws XMLStreamException
/*     */   {
/*  32 */     writer.writeEndDocument();
/*  33 */     writer.flush();
/*  34 */     writer.close();
/*     */   }
/*     */   
/*     */   public static void writeOptions(XMLStreamWriter writer, Map<String, String> optionsMap, String entityName)
/*     */     throws XMLStreamException
/*     */   {
/*  40 */     writeTagWithResultsCount(writer, "options", optionsMap.size());
/*     */     
/*     */ 
/*  43 */     for (Map.Entry<String, String> optionEntry : optionsMap.entrySet())
/*     */     {
/*  45 */       writer.writeStartElement("row");
/*  46 */       writer.writeStartElement("name");
/*  47 */       writer.writeCharacters((String)optionEntry.getKey());
/*  48 */       writer.writeEndElement();
/*  49 */       writer.writeStartElement("value");
/*  50 */       if (null != optionEntry.getValue()) {
/*  51 */         writer.writeCharacters((String)optionEntry.getValue());
/*     */       } else {
/*  53 */         writer.writeCharacters("null");
/*     */       }
/*  55 */       writer.writeEndElement();
/*  56 */       writer.writeEndElement();
/*     */     }
/*     */     
/*  59 */     writer.writeEndElement();
/*     */   }
/*     */   
/*     */ 
/*     */   public static void writeStatusResponseXml(XMLStreamWriter writer, String requestId, String responseTime, String clientId, String statusCode)
/*     */     throws XMLStreamException
/*     */   {
/*  66 */     writer.writeStartElement("status");
/*  67 */     if (requestId != null)
/*  68 */       writer.writeAttribute("request_id", requestId);
/*  69 */     if (responseTime != null) {
/*  70 */       writer.writeAttribute("response_time", responseTime);
/*     */     }
/*  72 */     writer.writeStartElement("client_id");
/*  73 */     if (clientId != null)
/*  74 */       writer.writeCharacters(clientId);
/*  75 */     writer.writeEndElement();
/*  76 */     writer.writeStartElement("status_code");
/*  77 */     if (statusCode != null)
/*  78 */       writer.writeCharacters(statusCode);
/*  79 */     writer.writeEndElement();
/*  80 */     writer.writeEndElement();
/*     */   }
/*     */   
/*     */ 
/*     */   public static void writeStatusResponseXml(XMLStreamWriter writer, String requestId, String responseTime, String clientId, String statusCode, String error_code, String message, String message_type)
/*     */     throws XMLStreamException
/*     */   {
/*  87 */     writer.writeStartElement("status");
/*  88 */     if (requestId != null)
/*  89 */       writer.writeAttribute("request_id", requestId);
/*  90 */     if (responseTime != null) {
/*  91 */       writer.writeAttribute("response_time", responseTime);
/*     */     }
/*  93 */     writer.writeStartElement("client_id");
/*  94 */     if (clientId != null)
/*  95 */       writer.writeCharacters(clientId);
/*  96 */     writer.writeEndElement();
/*  97 */     writer.writeStartElement("status_code");
/*  98 */     if (statusCode != null)
/*  99 */       writer.writeCharacters(statusCode);
/* 100 */     writer.writeEndElement();
/* 101 */     if (error_code != null) {
/* 102 */       writer.writeStartElement("error_code");
/* 103 */       writer.writeCharacters(error_code);
/* 104 */       writer.writeEndElement();
/* 105 */       writer.writeStartElement("message");
/* 106 */       writer.writeAttribute("type", message_type);
/* 107 */       writer.writeCharacters(message);
/* 108 */       writer.writeEndElement();
/*     */     }
/* 110 */     writer.writeEndElement();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public static void writeDefaultXmlWithStatusTag(String statusCode, XMLStreamWriter writer)
/*     */     throws XMLStreamException
/*     */   {
/* 118 */     writer.writeStartElement("status");
/* 119 */     writer.writeAttribute("request_id", "dummy");
/* 120 */     writer.writeAttribute("response_time", "dummy");
/* 121 */     writer.writeStartElement("client_id");
/*     */     
/* 123 */     writer.writeCharacters("dummyClient");
/* 124 */     writer.writeEndElement();
/* 125 */     writer.writeStartElement("status_code");
/* 126 */     writer.writeCharacters(statusCode);
/* 127 */     writer.writeEndElement();
/*     */   }
/*     */   
/*     */   public static void writeTagWithResultsCount(XMLStreamWriter writer, String tagName, int count) throws XMLStreamException
/*     */   {
/* 132 */     writer.writeStartElement(tagName);
/* 133 */     writer.writeAttribute("results_count", String.valueOf(count));
/*     */   }
/*     */   
/*     */ 
/*     */   public static String getObjectViewURL(String entityName, String instanceKey, String rowKey, String serverUrl)
/*     */   {
/* 139 */     StringBuilder stringBuilder = new StringBuilder();
/* 140 */     stringBuilder.append(serverUrl).append("biz_key").append("/").append(rowKey).append("/").append("object_view").append("/").append(entityName.toString());
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 145 */     if (instanceKey != null) {
/* 146 */       stringBuilder.append("/").append("instance_key").append("/").append(instanceKey);
/*     */     }
/*     */     
/*     */ 
/* 150 */     return stringBuilder.toString();
/*     */   }
/*     */   
/*     */   public static void writeElement(String tagName, String tagValue, XMLStreamWriter writer) throws XMLStreamException
/*     */   {
/* 155 */     writer.writeStartElement(tagName);
/* 156 */     writer.writeCharacters(tagValue);
/* 157 */     writer.writeEndElement();
/*     */   }
/*     */   
/*     */   public static void writeObjectViewElement(XMLStreamWriter writer, String objectViewUrl) throws XMLStreamException
/*     */   {
/* 162 */     writer.writeStartElement("object_view");
/* 163 */     writer.writeCharacters(objectViewUrl);
/* 164 */     writer.writeEndElement();
/*     */   }
/*     */   
/*     */   public static void writeParents(XMLStreamWriter writer, Map<String, String> parentMap, String rowKey, String serverUrl)
/*     */     throws XMLStreamException
/*     */   {
/* 170 */     if (parentMap.size() > 0) {
/* 171 */       writeTagWithResultsCount(writer, "parents", parentMap.size());
/*     */       
/*     */ 
/* 174 */       for (String name : parentMap.keySet()) {
/* 175 */         writeRelationWithObjectViewElement("parent", name, writer, rowKey, serverUrl);
/*     */         
/*     */ 
/* 178 */         writeTagWithResultsCount(writer, "rows", 1);
/* 179 */         writeRowTagWithObjectViewUrl(writer, (String)parentMap.get(name), name, rowKey, serverUrl);
/*     */         
/*     */ 
/* 182 */         writer.writeEndElement();
/* 183 */         writer.writeEndElement();
/*     */       }
/* 185 */       writer.writeEndElement();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public static void writeChildren(XMLStreamWriter writer, Map<Utf8, List<Utf8>> childs, String rowKey, String serverUrl)
/*     */     throws XMLStreamException
/*     */   {
/* 193 */     if (childs == null)
/* 194 */       return;
/* 195 */     writeTagWithResultsCount(writer, "childs", childs.size());
/*     */     
/* 197 */     List<Utf8> childIdentifiers = null;
/* 198 */     for (Utf8 name : childs.keySet()) {
/* 199 */       childIdentifiers = (List)childs.get(name);
/* 200 */       writeRelationWithObjectViewElement("child", name.toString(), writer, rowKey, serverUrl);
/*     */       
/*     */ 
/* 203 */       writeTagWithResultsCount(writer, "rows", childIdentifiers.size());
/*     */       
/*     */ 
/* 206 */       for (Utf8 attributeValue : childIdentifiers) {
/* 207 */         writeRowTagWithObjectViewUrl(writer, attributeValue.toString(), name.toString(), rowKey, serverUrl);
/*     */       }
/*     */       
/* 210 */       writer.writeEndElement();
/* 211 */       writer.writeEndElement();
/*     */     }
/* 213 */     writer.writeEndElement();
/*     */   }
/*     */   
/*     */ 
/*     */   private static void writeRowTagWithObjectViewUrl(XMLStreamWriter writer, String instanceKey, String entityName, String rowKey, String serverUrl)
/*     */     throws XMLStreamException
/*     */   {
/* 220 */     instanceKey = getEncodedURL(instanceKey);
/* 221 */     writer.writeStartElement("row");
/*     */     
/* 223 */     writer.writeStartElement("instance_key");
/*     */     
/* 225 */     writer.writeCharacters(instanceKey);
/* 226 */     writer.writeEndElement();
/*     */     
/* 228 */     writer.writeStartElement("object_view");
/* 229 */     writer.writeCharacters(getObjectViewURL(entityName, instanceKey, rowKey, serverUrl));
/*     */     
/* 231 */     writer.writeEndElement();
/*     */     
/* 233 */     writer.writeEndElement();
/*     */   }
/*     */   
/*     */   private static void writeRelationWithObjectViewElement(String relationshipName, String entityName, XMLStreamWriter writer, String rowKey, String serverUrl)
/*     */     throws XMLStreamException
/*     */   {
/* 239 */     writer.writeStartElement(relationshipName);
/*     */     
/* 241 */     writer.writeStartElement("name");
/* 242 */     writer.writeCharacters(entityName.toString());
/* 243 */     writer.writeEndElement();
/*     */     
/* 245 */     writeObjectViewElement(writer, getObjectViewURL(entityName, null, rowKey, serverUrl));
/*     */   }
/*     */   
/*     */ 
/*     */   public static void writeConfigAndStatusAttrs(XMLStreamWriter writer, Map<String, String> configStatusAttrs)
/*     */     throws XMLStreamException
/*     */   {
/* 252 */     String attrValue = null;
/* 253 */     String attrName = null;
/* 254 */     for (Map.Entry<String, String> mapEntry : configStatusAttrs.entrySet()) {
/* 255 */       attrName = (String)mapEntry.getKey();
/* 256 */       attrValue = (String)mapEntry.getValue();
/* 257 */       if (attrValue != null) {
/* 258 */         writer.writeStartElement(attrName);
/* 259 */         attrValue = getEncodedURL(attrValue);
/* 260 */         writer.writeCharacters(attrValue);
/* 261 */         writer.writeEndElement();
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public static String getEncodedURL(String requestURL) {
/* 267 */     String encodedURL = requestURL;
/*     */     try {
/* 269 */       if (requestURL != null) {
/* 270 */         encodedURL = URLEncoder.encode(requestURL, "UTF-8");
/*     */       }
/*     */     }
/*     */     catch (Exception e) {}
/* 274 */     return encodedURL;
/*     */   }
/*     */   
/*     */ 
/*     */   public static String writeDefaultXmlWithZeroResults(String statusCode, String requestId, String clientId, String responseTime)
/*     */     throws FactoryConfigurationError, XMLStreamException, UnsupportedEncodingException
/*     */   {
/* 281 */     ByteArrayOutputStream outStream = new ByteArrayOutputStream();
/* 282 */     XMLStreamWriter writer = initializeXmlWriter(outStream);
/*     */     
/* 284 */     writeStatusResponseXml(writer, requestId, responseTime, clientId, statusCode);
/*     */     
/* 286 */     writeTagWithResultsCount(writer, "results", 0);
/* 287 */     writer.writeEndDocument();
/* 288 */     closeXmlWriter(writer);
/* 289 */     return outStream.toString("UTF-8");
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\client\helper\XMLHelper.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */