/*     */ package com.netapp.asup.data.function.filter;
/*     */ 
/*     */ import com.netapp.asup.data.function.FilterFunctionAttribute;
/*     */ import com.netapp.asup.data.function.FunctionAttribute;
/*     */ import com.netapp.asup.data.function.RegisteredFunction;
/*     */ import com.netapp.asup.util.StringUtils;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class FilterInputImpl
/*     */   implements FilterInput
/*     */ {
/*  18 */   private final Map<String, List<FilterField>> filterMap = new HashMap();
/*     */   
/*     */   public Map<String, List<FilterField>> getFilterMap() {
/*  21 */     return this.filterMap;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void addAttribute(String path, FilterFunctionAttribute... filterAttrs)
/*     */   {
/*  28 */     validate(path, filterAttrs);
/*     */     
/*  30 */     List<FilterField> filterList = getFilterListForPath(path);
/*  31 */     for (FilterFunctionAttribute filterFunctionAttribute : filterAttrs) {
/*  32 */       filterList.add(new FilterField(filterFunctionAttribute.getAttrName(), filterFunctionAttribute.getAttrValue()));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public List<FilterField> getFilterListForPath(String path)
/*     */   {
/*  39 */     path = path.replaceFirst("^/", "");
/*  40 */     List<FilterField> list = (List)this.filterMap.get(path);
/*  41 */     if (list == null) {
/*  42 */       list = new ArrayList();
/*  43 */       this.filterMap.put(path, list);
/*     */     }
/*  45 */     return list;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void addExpression(String path, String attributeName, String expression, FunctionAttribute... attributeNames)
/*     */   {
/*  52 */     validate(path, attributeNames);
/*     */     
/*  54 */     if (StringUtils.isEmpty(expression)) {
/*  55 */       throw new IllegalArgumentException("Invalid expression:" + expression);
/*     */     }
/*     */     
/*     */ 
/*  59 */     if (StringUtils.isEmpty(attributeName)) {
/*  60 */       throw new IllegalArgumentException("Invalid attribute Name:" + attributeName);
/*     */     }
/*     */     
/*     */ 
/*  64 */     List<FilterField> filterList = getFilterListForPath(path);
/*  65 */     filterList.add(new FilterField(attributeName, expression, attributeNames));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void addCustomFunction(String path, RegisteredFunction<Map<Utf8, Utf8>, Boolean> customFunction, Map<String, String> options)
/*     */   {
/*  72 */     validatePath(path);
/*     */     
/*  74 */     if ((null == customFunction) || (customFunction.getOutputHandler() == null)) {
/*  75 */       throw new IllegalArgumentException("Function should be valid with an output handler.Invalid filter function:" + customFunction);
/*     */     }
/*     */     
/*     */ 
/*  79 */     if (null == options) {
/*  80 */       options = new HashMap();
/*     */     }
/*     */     
/*  83 */     List<FilterField> filterList = getFilterListForPath(path);
/*  84 */     filterList.add(new FilterField(customFunction, options));
/*     */   }
/*     */   
/*     */   private void validate(String path, FunctionAttribute... filterAttrs)
/*     */   {
/*  89 */     validatePath(path);
/*     */     
/*  91 */     if (filterAttrs == null) {
/*  92 */       throw new IllegalArgumentException("Invalid attributes:" + filterAttrs + ", no attributes defined");
/*     */     }
/*     */     
/*     */ 
/*  96 */     FunctionAttribute functionAttribute = null;
/*  97 */     for (int i = 0; i < filterAttrs.length; i++) {
/*  98 */       functionAttribute = filterAttrs[i];
/*     */       
/* 100 */       if (null == functionAttribute) {
/* 101 */         throw new IllegalArgumentException("Null function attribute at index:" + i);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   private void validate(String path, FilterFunctionAttribute... filterAttrs)
/*     */   {
/* 108 */     validatePath(path);
/*     */     
/* 110 */     if (filterAttrs == null) {
/* 111 */       throw new IllegalArgumentException("Invalid attributes:" + filterAttrs + ", no attributes defined");
/*     */     }
/*     */     
/*     */ 
/* 115 */     FilterFunctionAttribute functionAttribute = null;
/* 116 */     for (int i = 0; i < filterAttrs.length; i++) {
/* 117 */       functionAttribute = filterAttrs[i];
/*     */       
/* 119 */       if (null == functionAttribute) {
/* 120 */         throw new IllegalArgumentException("Null filter function attribute at index:" + i);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   private void validatePath(String path)
/*     */   {
/* 127 */     if (StringUtils.isEmpty(path)) {
/* 128 */       throw new IllegalArgumentException("Path cannot be null or empty:" + path);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\filter\FilterInputImpl.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */