/*     */ package com.sun.xml.bind.v2.runtime.output;
/*     */ 
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Base64Data;
/*     */ import java.io.IOException;
/*     */ import javax.xml.bind.attachment.AttachmentMarshaller;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class MTOMXmlOutput
/*     */   extends XmlOutputAbstractImpl
/*     */ {
/*     */   private final XmlOutput next;
/*     */   private String nsUri;
/*     */   private String localName;
/*     */   
/*     */   public MTOMXmlOutput(XmlOutput next)
/*     */   {
/*  31 */     this.next = next;
/*     */   }
/*     */   
/*     */   public void startDocument(XMLSerializer serializer, boolean fragment, int[] nsUriIndex2prefixIndex, NamespaceContextImpl nsContext) throws IOException, SAXException, XMLStreamException {
/*  35 */     super.startDocument(serializer, fragment, nsUriIndex2prefixIndex, nsContext);
/*  36 */     this.next.startDocument(serializer, fragment, nsUriIndex2prefixIndex, nsContext);
/*     */   }
/*     */   
/*     */   public void endDocument(boolean fragment) throws IOException, SAXException, XMLStreamException {
/*  40 */     this.next.endDocument(fragment);
/*  41 */     super.endDocument(fragment);
/*     */   }
/*     */   
/*     */   public void beginStartTag(Name name) throws IOException, XMLStreamException {
/*  45 */     this.next.beginStartTag(name);
/*  46 */     this.nsUri = name.nsUri;
/*  47 */     this.localName = name.localName;
/*     */   }
/*     */   
/*     */   public void beginStartTag(int prefix, String localName) throws IOException, XMLStreamException {
/*  51 */     this.next.beginStartTag(prefix, localName);
/*  52 */     this.nsUri = this.nsContext.getNamespaceURI(prefix);
/*  53 */     this.localName = localName;
/*     */   }
/*     */   
/*     */   public void attribute(Name name, String value) throws IOException, XMLStreamException {
/*  57 */     this.next.attribute(name, value);
/*     */   }
/*     */   
/*     */   public void attribute(int prefix, String localName, String value) throws IOException, XMLStreamException {
/*  61 */     this.next.attribute(prefix, localName, value);
/*     */   }
/*     */   
/*     */   public void endStartTag() throws IOException, SAXException {
/*  65 */     this.next.endStartTag();
/*     */   }
/*     */   
/*     */   public void endTag(Name name) throws IOException, SAXException, XMLStreamException {
/*  69 */     this.next.endTag(name);
/*     */   }
/*     */   
/*     */   public void endTag(int prefix, String localName) throws IOException, SAXException, XMLStreamException {
/*  73 */     this.next.endTag(prefix, localName);
/*     */   }
/*     */   
/*     */   public void text(String value, boolean needsSeparatingWhitespace) throws IOException, SAXException, XMLStreamException {
/*  77 */     this.next.text(value, needsSeparatingWhitespace);
/*     */   }
/*     */   
/*     */   public void text(Pcdata value, boolean needsSeparatingWhitespace) throws IOException, SAXException, XMLStreamException {
/*  81 */     if (((value instanceof Base64Data)) && (!this.serializer.getInlineBinaryFlag())) {
/*  82 */       Base64Data b64d = (Base64Data)value;
/*     */       String cid;
/*  84 */       String cid; if (b64d.hasData()) {
/*  85 */         cid = this.serializer.attachmentMarshaller.addMtomAttachment(b64d.get(), 0, b64d.getDataLen(), b64d.getMimeType(), this.nsUri, this.localName);
/*     */       }
/*     */       else {
/*  88 */         cid = this.serializer.attachmentMarshaller.addMtomAttachment(b64d.getDataHandler(), this.nsUri, this.localName);
/*     */       }
/*     */       
/*  91 */       if (cid != null) {
/*  92 */         this.nsContext.getCurrent().push();
/*  93 */         int prefix = this.nsContext.declareNsUri("http://www.w3.org/2004/08/xop/include", "xop", false);
/*  94 */         beginStartTag(prefix, "Include");
/*  95 */         attribute(-1, "href", cid);
/*  96 */         endStartTag();
/*  97 */         endTag(prefix, "Include");
/*  98 */         this.nsContext.getCurrent().pop();
/*  99 */         return;
/*     */       }
/*     */     }
/* 102 */     this.next.text(value, needsSeparatingWhitespace);
/*     */   }
/*     */   
/*     */   public void flush() throws IOException, XMLStreamException {
/* 106 */     this.next.flush();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\output\MTOMXmlOutput.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */