/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import com.sun.xml.bind.WhiteSpaceProcessor;
/*     */ import com.sun.xml.fastinfoset.stax.StAXDocumentParser;
/*     */ import javax.xml.stream.Location;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class FastInfosetConnector
/*     */   extends StAXConnector
/*     */ {
/*     */   private final StAXDocumentParser fastInfosetStreamReader;
/*  24 */   boolean hasBase64Data = false;
/*     */   
/*  26 */   boolean firstCIIChunk = true;
/*     */   
/*     */ 
/*  29 */   private Base64Data base64Data = new Base64Data();
/*     */   
/*     */ 
/*  32 */   private StringBuilder buffer = new StringBuilder();
/*     */   
/*     */   public FastInfosetConnector(StAXDocumentParser fastInfosetStreamReader, XmlVisitor visitor)
/*     */   {
/*  36 */     super(visitor);
/*  37 */     fastInfosetStreamReader.setStringInterning(true);
/*  38 */     this.fastInfosetStreamReader = fastInfosetStreamReader;
/*     */   }
/*     */   
/*     */   public void bridge() throws XMLStreamException
/*     */   {
/*     */     try {
/*  44 */       int depth = 0;
/*     */       
/*     */ 
/*  47 */       int event = this.fastInfosetStreamReader.getEventType();
/*  48 */       if (event == 7)
/*     */       {
/*  50 */         while (!this.fastInfosetStreamReader.isStartElement()) {
/*  51 */           event = this.fastInfosetStreamReader.next();
/*     */         }
/*     */       }
/*     */       
/*  55 */       if (event != 1) {
/*  56 */         throw new IllegalStateException("The current event is not START_ELEMENT\n but " + event);
/*     */       }
/*     */       
/*     */ 
/*  60 */       handleStartDocument(this.fastInfosetStreamReader.getNamespaceContext());
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */       for (;;)
/*     */       {
/*  67 */         switch (event) {
/*     */         case 1: 
/*  69 */           handleStartElement();
/*  70 */           depth++;
/*  71 */           break;
/*     */         case 2: 
/*  73 */           depth--;
/*  74 */           handleEndElement();
/*  75 */           if (depth != 0) {
/*     */             break;
/*     */           }
/*     */           break;
/*     */         case 4: case 6: case 12: 
/*  80 */           handleCharacters();
/*     */         }
/*     */         
/*     */         
/*     */ 
/*  85 */         event = this.fastInfosetStreamReader.next();
/*     */       }
/*     */       
/*  88 */       this.fastInfosetStreamReader.next();
/*     */       
/*  90 */       handleEndDocument();
/*     */     } catch (SAXException e) {
/*  92 */       throw new XMLStreamException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   protected Location getCurrentLocation() {
/*  97 */     return this.fastInfosetStreamReader.getLocation();
/*     */   }
/*     */   
/*     */   protected String getCurrentQName() {
/* 101 */     return this.fastInfosetStreamReader.getNameString();
/*     */   }
/*     */   
/*     */   private void handleStartElement() throws SAXException {
/* 105 */     processText(true);
/*     */     
/* 107 */     for (int i = 0; i < this.fastInfosetStreamReader.getNamespaceCount(); i++) {
/* 108 */       this.visitor.startPrefixMapping(this.fastInfosetStreamReader.getNamespacePrefix(i), this.fastInfosetStreamReader.getNamespaceURI(i));
/*     */     }
/*     */     
/*     */ 
/* 112 */     this.tagName.uri = this.fastInfosetStreamReader.getNamespaceURI();
/* 113 */     this.tagName.local = this.fastInfosetStreamReader.getLocalName();
/* 114 */     this.tagName.atts = this.fastInfosetStreamReader.getAttributesHolder();
/*     */     
/* 116 */     this.visitor.startElement(this.tagName);
/*     */   }
/*     */   
/*     */   private void handleCharacters() {
/* 120 */     if (this.predictor.expectText())
/*     */     {
/* 122 */       if ((this.firstCIIChunk) && (this.fastInfosetStreamReader.getTextAlgorithmBytes() == null))
/*     */       {
/* 124 */         this.buffer.append(this.fastInfosetStreamReader.getTextCharacters(), this.fastInfosetStreamReader.getTextStart(), this.fastInfosetStreamReader.getTextLength());
/*     */         
/*     */ 
/* 127 */         this.firstCIIChunk = false;
/*     */       } else {
/* 129 */         if ((this.firstCIIChunk) && (this.fastInfosetStreamReader.getTextAlgorithmIndex() == 1))
/*     */         {
/* 131 */           this.firstCIIChunk = false;
/* 132 */           this.hasBase64Data = true;
/*     */           
/* 134 */           this.base64Data.set(this.fastInfosetStreamReader.getTextAlgorithmBytesClone(), null);
/* 135 */           return;
/*     */         }
/*     */         
/*     */ 
/* 139 */         if (this.hasBase64Data)
/*     */         {
/* 141 */           this.buffer.append(this.base64Data);
/* 142 */           this.hasBase64Data = false;
/*     */         }
/*     */         
/*     */ 
/* 146 */         this.buffer.append(this.fastInfosetStreamReader.getTextCharacters(), this.fastInfosetStreamReader.getTextStart(), this.fastInfosetStreamReader.getTextLength());
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   private void handleEndElement()
/*     */     throws SAXException
/*     */   {
/* 155 */     processText(false);
/*     */     
/* 157 */     this.tagName.uri = this.fastInfosetStreamReader.getNamespaceURI();
/* 158 */     this.tagName.local = this.fastInfosetStreamReader.getLocalName();
/*     */     
/* 160 */     this.visitor.endElement(this.tagName);
/*     */     
/* 162 */     for (int i = this.fastInfosetStreamReader.getNamespaceCount() - 1; i >= 0; i--) {
/* 163 */       this.visitor.endPrefixMapping(this.fastInfosetStreamReader.getNamespacePrefix(i));
/*     */     }
/*     */   }
/*     */   
/*     */   private void processText(boolean ignorable) throws SAXException {
/* 168 */     this.firstCIIChunk = true;
/* 169 */     if ((this.predictor.expectText()) && ((!ignorable) || (!WhiteSpaceProcessor.isWhiteSpace(this.buffer)))) {
/* 170 */       if (!this.hasBase64Data) {
/* 171 */         this.visitor.text(this.buffer);
/*     */       } else {
/* 173 */         this.visitor.text(this.base64Data);
/* 174 */         this.hasBase64Data = false;
/*     */       }
/*     */     }
/* 177 */     this.buffer.setLength(0);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\FastInfosetConnector.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */