/*     */ package net.rubyeye.xmemcached.buffer;
/*     */ 
/*     */ import com.google.code.yanf4j.util.CircularQueue;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.nio.ByteOrder;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import java.util.Queue;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @Deprecated
/*     */ public class CachedBufferAllocator
/*     */   implements BufferAllocator
/*     */ {
/*     */   private static final int DEFAULT_MAX_POOL_SIZE = 8;
/*     */   private static final int DEFAULT_MAX_CACHED_BUFFER_SIZE = 262144;
/*     */   private final int maxPoolSize;
/*     */   private final int maxCachedBufferSize;
/*     */   private final ThreadLocal<Map<Integer, Queue<CachedIoBuffer>>> heapBuffers;
/*  49 */   private final IoBuffer EMPTY_IO_BUFFER = new CachedIoBuffer(ByteBuffer.allocate(0));
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public CachedBufferAllocator()
/*     */   {
/*  57 */     this(8, 262144);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public CachedBufferAllocator(int maxPoolSize, int maxCachedBufferSize)
/*     */   {
/*  72 */     if (maxPoolSize < 0) {
/*  73 */       throw new IllegalArgumentException("maxPoolSize: " + maxPoolSize);
/*     */     }
/*  75 */     if (maxCachedBufferSize < 0) {
/*  76 */       throw new IllegalArgumentException("maxCachedBufferSize: " + maxCachedBufferSize);
/*     */     }
/*     */     
/*     */ 
/*  80 */     this.maxPoolSize = maxPoolSize;
/*  81 */     this.maxCachedBufferSize = maxCachedBufferSize;
/*     */     
/*  83 */     this.heapBuffers = new ThreadLocal()
/*     */     {
/*     */ 
/*     */       protected Map<Integer, Queue<CachedBufferAllocator.CachedIoBuffer>> initialValue()
/*     */       {
/*  88 */         return CachedBufferAllocator.this.newPoolMap();
/*     */       }
/*     */     };
/*     */   }
/*     */   
/*     */   public int getMaxPoolSize() {
/*  94 */     return this.maxPoolSize;
/*     */   }
/*     */   
/*     */   public int getMaxCachedBufferSize() {
/*  98 */     return this.maxCachedBufferSize;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private Map<Integer, Queue<CachedIoBuffer>> newPoolMap()
/*     */   {
/* 107 */     Map<Integer, Queue<CachedIoBuffer>> poolMap = new HashMap();
/* 108 */     int poolSize = this.maxPoolSize == 0 ? 8 : this.maxPoolSize;
/*     */     
/* 110 */     for (int i = 0; i < 31; i++) {
/* 111 */       poolMap.put(Integer.valueOf(1 << i), new CircularQueue(poolSize));
/*     */     }
/* 113 */     poolMap.put(Integer.valueOf(0), new CircularQueue(poolSize));
/* 114 */     poolMap.put(Integer.valueOf(Integer.MAX_VALUE), new CircularQueue(poolSize));
/*     */     
/* 116 */     return poolMap;
/*     */   }
/*     */   
/*     */   public final IoBuffer allocate(int requestedCapacity) {
/* 120 */     if (requestedCapacity == 0) {
/* 121 */       return this.EMPTY_IO_BUFFER;
/*     */     }
/*     */     
/* 124 */     int actualCapacity = ByteUtils.normalizeCapacity(requestedCapacity);
/*     */     IoBuffer buf;
/* 126 */     IoBuffer buf; if ((this.maxCachedBufferSize != 0) && (actualCapacity > this.maxCachedBufferSize))
/*     */     {
/* 128 */       buf = wrap(ByteBuffer.allocate(actualCapacity));
/*     */     }
/*     */     else {
/* 131 */       Queue<CachedIoBuffer> pool = (Queue)((Map)this.heapBuffers.get()).get(Integer.valueOf(actualCapacity));
/*     */       
/* 133 */       buf = (IoBuffer)pool.poll();
/* 134 */       if (buf != null) {
/* 135 */         buf.clear();
/*     */       } else {
/* 137 */         buf = wrap(ByteBuffer.allocate(actualCapacity));
/*     */       }
/*     */     }
/* 140 */     buf.limit(requestedCapacity);
/* 141 */     return buf;
/*     */   }
/*     */   
/*     */   public final IoBuffer wrap(ByteBuffer nioBuffer) {
/* 145 */     return new CachedIoBuffer(nioBuffer);
/*     */   }
/*     */   
/*     */   public void dispose() {
/* 149 */     this.heapBuffers.remove();
/*     */   }
/*     */   
/*     */   public static BufferAllocator newInstance() {
/* 153 */     return new CachedBufferAllocator();
/*     */   }
/*     */   
/*     */   public static BufferAllocator newInstance(int maxPoolSize, int maxCachedBufferSize)
/*     */   {
/* 158 */     return new CachedBufferAllocator(maxPoolSize, maxCachedBufferSize);
/*     */   }
/*     */   
/*     */   public class CachedIoBuffer implements IoBuffer
/*     */   {
/*     */     Thread ownerThread;
/*     */     ByteBuffer origBuffer;
/*     */     
/*     */     public CachedIoBuffer(ByteBuffer origBuffer)
/*     */     {
/* 168 */       this.ownerThread = Thread.currentThread();
/* 169 */       this.origBuffer = origBuffer;
/*     */     }
/*     */     
/*     */     public void putInt(int i)
/*     */     {
/* 174 */       this.origBuffer.putInt(i);
/*     */     }
/*     */     
/*     */ 
/*     */     public void putShort(short s)
/*     */     {
/* 180 */       this.origBuffer.putShort(s);
/*     */     }
/*     */     
/*     */     public ByteOrder order()
/*     */     {
/* 185 */       return this.origBuffer.order();
/*     */     }
/*     */     
/*     */     public boolean isDirect()
/*     */     {
/* 190 */       return this.origBuffer.isDirect();
/*     */     }
/*     */     
/*     */     public void order(ByteOrder byteOrder)
/*     */     {
/* 195 */       this.origBuffer.order(byteOrder);
/*     */     }
/*     */     
/*     */     public void putLong(long l) {
/* 199 */       this.origBuffer.putLong(l);
/*     */     }
/*     */     
/*     */     public final void free()
/*     */     {
/* 204 */       if ((this.origBuffer == null) || (this.origBuffer.capacity() > CachedBufferAllocator.this.maxCachedBufferSize) || (Thread.currentThread() != this.ownerThread))
/*     */       {
/*     */ 
/* 207 */         return;
/*     */       }
/*     */       
/*     */ 
/*     */ 
/* 212 */       Queue<CachedIoBuffer> pool = (Queue)((Map)CachedBufferAllocator.this.heapBuffers.get()).get(Integer.valueOf(this.origBuffer.capacity()));
/*     */       
/* 214 */       if (pool == null) {
/* 215 */         return;
/*     */       }
/*     */       
/* 218 */       if ((CachedBufferAllocator.this.maxPoolSize == 0) || (pool.size() < CachedBufferAllocator.this.maxPoolSize))
/*     */       {
/* 220 */         pool.offer(new CachedIoBuffer(CachedBufferAllocator.this, this.origBuffer));
/*     */       }
/* 222 */       this.origBuffer = null;
/*     */     }
/*     */     
/*     */ 
/*     */     public final ByteBuffer[] getByteBuffers()
/*     */     {
/* 228 */       return new ByteBuffer[] { this.origBuffer };
/*     */     }
/*     */     
/*     */     public final void put(byte[] bytes)
/*     */     {
/* 233 */       this.origBuffer.put(bytes);
/*     */     }
/*     */     
/*     */     public final int capacity()
/*     */     {
/* 238 */       return this.origBuffer.capacity();
/*     */     }
/*     */     
/*     */     public final void clear()
/*     */     {
/* 243 */       this.origBuffer.clear();
/*     */     }
/*     */     
/*     */     public final void reset()
/*     */     {
/* 248 */       this.origBuffer.reset();
/*     */     }
/*     */     
/*     */     public final int remaining()
/*     */     {
/* 253 */       return this.origBuffer.remaining();
/*     */     }
/*     */     
/*     */     public final int position()
/*     */     {
/* 258 */       return this.origBuffer.position();
/*     */     }
/*     */     
/*     */     public final void mark()
/*     */     {
/* 263 */       this.origBuffer.mark();
/*     */     }
/*     */     
/*     */     public final int limit()
/*     */     {
/* 268 */       return this.origBuffer.limit();
/*     */     }
/*     */     
/*     */     public final boolean hasRemaining()
/*     */     {
/* 273 */       return this.origBuffer.hasRemaining();
/*     */     }
/*     */     
/*     */     public final void flip()
/*     */     {
/* 278 */       this.origBuffer.flip();
/*     */     }
/*     */     
/*     */     public final void put(byte b)
/*     */     {
/* 283 */       this.origBuffer.put(b);
/*     */     }
/*     */     
/*     */     public final void put(ByteBuffer buff)
/*     */     {
/* 288 */       this.origBuffer.put(buff);
/*     */     }
/*     */     
/*     */     public final ByteBuffer getByteBuffer()
/*     */     {
/* 293 */       return this.origBuffer;
/*     */     }
/*     */     
/*     */     public final void limit(int limit)
/*     */     {
/* 298 */       this.origBuffer.limit(limit);
/*     */     }
/*     */     
/*     */     public final void position(int pos)
/*     */     {
/* 303 */       this.origBuffer.position(pos);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\buffer\CachedBufferAllocator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */