/*     */ package net.rubyeye.xmemcached.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.core.Session;
/*     */ import java.net.InetSocketAddress;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.Collections;
/*     */ import java.util.List;
/*     */ import java.util.Random;
/*     */ import net.rubyeye.xmemcached.HashAlgorithm;
/*     */ import net.rubyeye.xmemcached.networking.MemcachedSession;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ArrayMemcachedSessionLocator
/*     */   extends AbstractMemcachedSessionLocator
/*     */ {
/*     */   private HashAlgorithm hashAlgorighm;
/*     */   private volatile transient List<List<Session>> sessions;
/*     */   
/*     */   public ArrayMemcachedSessionLocator()
/*     */   {
/*  38 */     this.hashAlgorighm = HashAlgorithm.NATIVE_HASH;
/*     */   }
/*     */   
/*     */   public ArrayMemcachedSessionLocator(HashAlgorithm hashAlgorighm) {
/*  42 */     this.hashAlgorighm = hashAlgorighm;
/*     */   }
/*     */   
/*     */   public final void setHashAlgorighm(HashAlgorithm hashAlgorighm) {
/*  46 */     this.hashAlgorighm = hashAlgorighm;
/*     */   }
/*     */   
/*     */   public final long getHash(int size, String key) {
/*  50 */     long hash = this.hashAlgorighm.hash(key);
/*  51 */     return hash % size;
/*     */   }
/*     */   
/*  54 */   final Random rand = new Random();
/*     */   
/*     */   public final Session getSessionByKey(String key) {
/*  57 */     if ((this.sessions == null) || (this.sessions.size() == 0)) {
/*  58 */       return null;
/*     */     }
/*     */     
/*  61 */     List<List<Session>> sessionList = this.sessions;
/*  62 */     int size = sessionList.size();
/*  63 */     if (size == 0) {
/*  64 */       return null;
/*     */     }
/*  66 */     long start = getHash(size, key);
/*  67 */     List<Session> sessions = (List)sessionList.get((int)start);
/*  68 */     Session session = getRandomSession(sessions);
/*     */     
/*     */ 
/*  71 */     if ((!this.failureMode) && ((session == null) || (session.isClosed()))) {
/*  72 */       long next = getNext(size, start);
/*  73 */       while (((session == null) || (session.isClosed())) && (next != start)) {
/*  74 */         sessions = (List)sessionList.get((int)next);
/*  75 */         next = getNext(size, next);
/*  76 */         session = getRandomSession(sessions);
/*     */       }
/*     */     }
/*  79 */     return session;
/*     */   }
/*     */   
/*     */   private Session getRandomSession(List<Session> sessions) {
/*  83 */     if ((sessions == null) || (sessions.isEmpty()))
/*  84 */       return null;
/*  85 */     return (Session)sessions.get(this.rand.nextInt(sessions.size()));
/*     */   }
/*     */   
/*     */   public final long getNext(int size, long start) {
/*  89 */     if (start == size - 1) {
/*  90 */       return 0L;
/*     */     }
/*  92 */     return start + 1L;
/*     */   }
/*     */   
/*     */   public final void updateSessions(Collection<Session> list)
/*     */   {
/*  97 */     if ((list == null) || (list.isEmpty())) {
/*  98 */       this.sessions = Collections.emptyList();
/*  99 */       return;
/*     */     }
/* 101 */     Collection<Session> copySessions = list;
/* 102 */     List<List<Session>> tmpList = new ArrayList();
/* 103 */     Session target = null;
/* 104 */     List<Session> subList = null;
/* 105 */     for (Session session : copySessions) {
/* 106 */       if (target == null) {
/* 107 */         target = session;
/* 108 */         subList = new ArrayList();
/* 109 */         subList.add(target);
/*     */       }
/* 111 */       else if (session.getRemoteSocketAddress().equals(target.getRemoteSocketAddress()))
/*     */       {
/* 113 */         subList.add(session);
/*     */       } else {
/* 115 */         tmpList.add(subList);
/* 116 */         target = session;
/* 117 */         subList = new ArrayList();
/* 118 */         subList.add(target);
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 124 */     if (subList != null) {
/* 125 */       tmpList.add(subList);
/*     */     }
/*     */     
/* 128 */     List<List<Session>> newSessions = new ArrayList(tmpList.size() * 2);
/*     */     
/* 130 */     for (List<Session> sessions : tmpList) {
/* 131 */       if ((sessions != null) && (!sessions.isEmpty())) {
/* 132 */         Session session = (Session)sessions.get(0);
/* 133 */         if ((session instanceof MemcachedTCPSession)) {
/* 134 */           int weight = ((MemcachedSession)session).getWeight();
/* 135 */           for (int i = 0; i < weight; i++) {
/* 136 */             newSessions.add(sessions);
/*     */           }
/*     */         } else {
/* 139 */           newSessions.add(sessions);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/* 144 */     this.sessions = newSessions;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\impl\ArrayMemcachedSessionLocator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */