/*     */ package net.rubyeye.xmemcached.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.config.Configuration;
/*     */ import com.google.code.yanf4j.core.Controller;
/*     */ import com.google.code.yanf4j.core.ControllerStateListener;
/*     */ import com.google.code.yanf4j.core.EventType;
/*     */ import com.google.code.yanf4j.core.Session;
/*     */ import com.google.code.yanf4j.core.WriteMessage;
/*     */ import com.google.code.yanf4j.nio.NioSession;
/*     */ import com.google.code.yanf4j.nio.NioSessionConfig;
/*     */ import com.google.code.yanf4j.nio.impl.SelectorManager;
/*     */ import com.google.code.yanf4j.nio.impl.SocketChannelController;
/*     */ import com.google.code.yanf4j.util.ConcurrentHashSet;
/*     */ import com.google.code.yanf4j.util.SystemUtils;
/*     */ import java.io.IOException;
/*     */ import java.net.InetAddress;
/*     */ import java.net.InetSocketAddress;
/*     */ import java.nio.channels.SelectableChannel;
/*     */ import java.nio.channels.SelectionKey;
/*     */ import java.nio.channels.Selector;
/*     */ import java.nio.channels.SocketChannel;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.Collections;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Queue;
/*     */ import java.util.Random;
/*     */ import java.util.Set;
/*     */ import java.util.concurrent.ConcurrentHashMap;
/*     */ import java.util.concurrent.ConcurrentLinkedQueue;
/*     */ import java.util.concurrent.CopyOnWriteArrayList;
/*     */ import java.util.concurrent.DelayQueue;
/*     */ import java.util.concurrent.ExecutionException;
/*     */ import java.util.concurrent.Future;
/*     */ import java.util.concurrent.TimeUnit;
/*     */ import java.util.concurrent.TimeoutException;
/*     */ import net.rubyeye.xmemcached.CommandFactory;
/*     */ import net.rubyeye.xmemcached.FlowControl;
/*     */ import net.rubyeye.xmemcached.MemcachedOptimizer;
/*     */ import net.rubyeye.xmemcached.MemcachedSessionLocator;
/*     */ import net.rubyeye.xmemcached.buffer.BufferAllocator;
/*     */ import net.rubyeye.xmemcached.command.Command;
/*     */ import net.rubyeye.xmemcached.exception.MemcachedException;
/*     */ import net.rubyeye.xmemcached.networking.Connector;
/*     */ import net.rubyeye.xmemcached.networking.MemcachedSession;
/*     */ import net.rubyeye.xmemcached.utils.InetSocketAddressWrapper;
/*     */ import net.rubyeye.xmemcached.utils.Protocol;
/*     */ import org.slf4j.Logger;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class MemcachedConnector
/*     */   extends SocketChannelController
/*     */   implements Connector
/*     */ {
/*  71 */   private final DelayQueue<ReconnectRequest> waitingQueue = new DelayQueue();
/*     */   
/*     */   private BufferAllocator bufferAllocator;
/*  74 */   private final Set<InetSocketAddress> removedAddrSet = new ConcurrentHashSet();
/*     */   
/*     */   private final MemcachedOptimizer optimiezer;
/*  77 */   private volatile long healSessionInterval = 2000L;
/*     */   
/*     */   private int connectionPoolSize;
/*     */   
/*     */   protected Protocol protocol;
/*     */   private final CommandFactory commandFactory;
/*     */   private volatile boolean failureMode;
/*  84 */   private final ConcurrentHashMap<InetSocketAddress, List<Session>> standbySessionMap = new ConcurrentHashMap();
/*     */   
/*     */   private FlowControl flowControl;
/*     */   
/*     */   protected MemcachedSessionLocator sessionLocator;
/*     */   
/*     */   public void setSessionLocator(MemcachedSessionLocator sessionLocator)
/*     */   {
/*  92 */     this.sessionLocator = sessionLocator;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   class SessionMonitor
/*     */     extends Thread
/*     */   {
/*     */     public SessionMonitor()
/*     */     {
/* 103 */       setName("Heal-Session-Thread");
/*     */     }
/*     */     
/*     */     public void run()
/*     */     {
/* 108 */       while (MemcachedConnector.this.isStarted()) {
/* 109 */         ReconnectRequest request = null;
/*     */         try {
/* 111 */           request = (ReconnectRequest)MemcachedConnector.this.waitingQueue.take();
/*     */           
/* 113 */           InetSocketAddress address = request.getInetSocketAddressWrapper().getInetSocketAddress();
/*     */           
/*     */ 
/*     */ 
/* 117 */           if (!MemcachedConnector.this.removedAddrSet.contains(address))
/*     */           {
/* 119 */             boolean connected = false;
/* 120 */             Future<Boolean> future = MemcachedConnector.this.connect(request.getInetSocketAddressWrapper());
/*     */             
/* 122 */             request.setTries(request.getTries() + 1);
/*     */             try {
/* 124 */               MemcachedConnector.log.warn("Trying to connect to " + address.getAddress().getHostAddress() + ":" + address.getPort() + " for " + request.getTries() + " times");
/*     */               
/*     */ 
/*     */ 
/* 128 */               if (!((Boolean)future.get(60000L, TimeUnit.MILLISECONDS)).booleanValue())
/*     */               {
/*     */ 
/* 131 */                 connected = false;
/*     */               } else {
/* 133 */                 connected = true;
/*     */               }
/*     */               
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 140 */               if (!connected) {
/* 141 */                 rescheduleConnectRequest(request);
/*     */                 break label253; }
/* 143 */               continue;
/*     */             }
/*     */             catch (TimeoutException e)
/*     */             {
/* 136 */               future.cancel(true);
/*     */               
/*     */ 
/*     */ 
/* 140 */               if (!connected) {
/* 141 */                 rescheduleConnectRequest(request);
/*     */                 break label253; }
/* 143 */               continue;
/*     */             }
/*     */             catch (ExecutionException e)
/*     */             {
/* 138 */               future.cancel(true);
/*     */               
/* 140 */               if (!connected) {
/* 141 */                 rescheduleConnectRequest(request);
/*     */                 break label253; }
/* 143 */               continue;
/*     */             }
/*     */             finally
/*     */             {
/* 140 */               if (!connected) {
/* 141 */                 rescheduleConnectRequest(request);
/*     */                 break label250; } }
/* 143 */             continue; label250: throw ((Throwable)localObject);
/*     */           }
/*     */           else {
/*     */             label253:
/* 147 */             MemcachedConnector.log.warn("Remove invalid reconnect task for " + address);
/*     */           }
/*     */           
/*     */         }
/*     */         catch (InterruptedException e) {}catch (Exception e)
/*     */         {
/* 153 */           MemcachedConnector.log.error("SessionMonitor connect error", e);
/* 154 */           rescheduleConnectRequest(request);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */     private void rescheduleConnectRequest(ReconnectRequest request) {
/* 160 */       if (request == null) {
/* 161 */         return;
/*     */       }
/* 163 */       InetSocketAddress address = request.getInetSocketAddressWrapper().getInetSocketAddress();
/*     */       
/*     */ 
/* 166 */       request.updateNextReconnectTimeStamp(MemcachedConnector.this.healSessionInterval * request.getTries());
/*     */       
/* 168 */       MemcachedConnector.log.error("Reconnect to " + address.getAddress().getHostAddress() + ":" + address.getPort() + " fail");
/*     */       
/*     */ 
/* 171 */       MemcachedConnector.this.waitingQueue.offer(request);
/*     */     }
/*     */   }
/*     */   
/*     */   public Queue<ReconnectRequest> getReconnectRequestQueue() {
/* 176 */     return this.waitingQueue;
/*     */   }
/*     */   
/*     */   public Set<Session> getSessionSet()
/*     */   {
/* 181 */     Collection<Queue<Session>> sessionQueues = this.sessionMap.values();
/* 182 */     Set<Session> result = new HashSet();
/* 183 */     for (Queue<Session> queue : sessionQueues) {
/* 184 */       result.addAll(queue);
/*     */     }
/* 186 */     return result;
/*     */   }
/*     */   
/*     */   public final void setHealSessionInterval(long healConnectionInterval) {
/* 190 */     this.healSessionInterval = healConnectionInterval;
/*     */   }
/*     */   
/*     */   public long getHealSessionInterval() {
/* 194 */     return this.healSessionInterval;
/*     */   }
/*     */   
/*     */   public void setOptimizeGet(boolean optimiezeGet) {
/* 198 */     ((OptimizerMBean)this.optimiezer).setOptimizeGet(optimiezeGet);
/*     */   }
/*     */   
/*     */   public void setOptimizeMergeBuffer(boolean optimizeMergeBuffer) {
/* 202 */     ((OptimizerMBean)this.optimiezer).setOptimizeMergeBuffer(optimizeMergeBuffer);
/*     */   }
/*     */   
/*     */   public Protocol getProtocol()
/*     */   {
/* 207 */     return this.protocol;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/* 212 */   protected final ConcurrentHashMap<InetSocketAddress, Queue<Session>> sessionMap = new ConcurrentHashMap();
/*     */   
/*     */   public synchronized void addSession(Session session) {
/* 215 */     MemcachedSession tcpSession = (MemcachedSession)session;
/* 216 */     InetSocketAddressWrapper addrWrapper = tcpSession.getInetSocketAddressWrapper();
/*     */     
/*     */ 
/* 219 */     InetSocketAddress mainNodeAddress = addrWrapper.getMainNodeAddress();
/* 220 */     if (mainNodeAddress != null)
/*     */     {
/* 222 */       addStandbySession(session, mainNodeAddress);
/*     */     }
/*     */     else {
/* 225 */       addMainSession(session);
/*     */       
/* 227 */       updateSessions();
/*     */     }
/*     */   }
/*     */   
/*     */   private void addMainSession(Session session) {
/* 232 */     InetSocketAddress remoteSocketAddress = session.getRemoteSocketAddress();
/*     */     
/* 234 */     log.warn("Add a session: " + SystemUtils.getRawAddress(remoteSocketAddress) + ":" + remoteSocketAddress.getPort());
/*     */     
/*     */ 
/* 237 */     Queue<Session> sessions = (Queue)this.sessionMap.get(remoteSocketAddress);
/* 238 */     if (sessions == null) {
/* 239 */       sessions = new ConcurrentLinkedQueue();
/* 240 */       Queue<Session> oldSessions = (Queue)this.sessionMap.putIfAbsent(remoteSocketAddress, sessions);
/*     */       
/* 242 */       if (null != oldSessions) {
/* 243 */         sessions = oldSessions;
/*     */       }
/*     */     }
/*     */     
/* 247 */     if (this.failureMode) {
/* 248 */       Iterator<Session> it = sessions.iterator();
/* 249 */       while (it.hasNext()) {
/* 250 */         Session tmp = (Session)it.next();
/* 251 */         if (tmp.isClosed()) {
/* 252 */           it.remove();
/* 253 */           break;
/*     */         }
/*     */       }
/*     */     }
/*     */     
/* 258 */     sessions.offer(session);
/*     */     
/* 260 */     while (sessions.size() > this.connectionPoolSize) {
/* 261 */       Session oldSession = (Session)sessions.poll();
/* 262 */       ((MemcachedSession)oldSession).setAllowReconnect(false);
/* 263 */       oldSession.close();
/*     */     }
/*     */   }
/*     */   
/*     */   private void addStandbySession(Session session, InetSocketAddress mainNodeAddress)
/*     */   {
/* 269 */     InetSocketAddress remoteSocketAddress = session.getRemoteSocketAddress();
/*     */     
/* 271 */     log.warn("Add a standby session: " + SystemUtils.getRawAddress(remoteSocketAddress) + ":" + remoteSocketAddress.getPort() + " for " + SystemUtils.getRawAddress(mainNodeAddress) + ":" + mainNodeAddress.getPort());
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 276 */     List<Session> sessions = (List)this.standbySessionMap.get(mainNodeAddress);
/* 277 */     if (sessions == null) {
/* 278 */       sessions = new CopyOnWriteArrayList();
/* 279 */       List<Session> oldSessions = (List)this.standbySessionMap.putIfAbsent(mainNodeAddress, sessions);
/*     */       
/* 281 */       if (null != oldSessions) {
/* 282 */         sessions = oldSessions;
/*     */       }
/*     */     }
/* 285 */     sessions.add(session);
/*     */   }
/*     */   
/*     */   public List<Session> getSessionListBySocketAddress(InetSocketAddress inetSocketAddress)
/*     */   {
/* 290 */     Queue<Session> queue = (Queue)this.sessionMap.get(inetSocketAddress);
/* 291 */     if (queue != null) {
/* 292 */       return new ArrayList(queue);
/*     */     }
/* 294 */     return null;
/*     */   }
/*     */   
/*     */   public void removeReconnectRequest(InetSocketAddress inetSocketAddress)
/*     */   {
/* 299 */     this.removedAddrSet.add(inetSocketAddress);
/* 300 */     Iterator<ReconnectRequest> it = this.waitingQueue.iterator();
/* 301 */     while (it.hasNext()) {
/* 302 */       ReconnectRequest request = (ReconnectRequest)it.next();
/* 303 */       if (request.getInetSocketAddressWrapper().getInetSocketAddress().equals(inetSocketAddress))
/*     */       {
/* 305 */         it.remove();
/* 306 */         log.warn("Remove invalid reconnect task for " + request.getInetSocketAddressWrapper().getInetSocketAddress());
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/* 313 */   private static final MemcachedSessionComparator sessionComparator = new MemcachedSessionComparator();
/*     */   
/*     */   public final void updateSessions() {
/* 316 */     Collection<Queue<Session>> sessionCollection = this.sessionMap.values();
/* 317 */     List<Session> sessionList = new ArrayList(20);
/* 318 */     for (Queue<Session> sessions : sessionCollection) {
/* 319 */       sessionList.addAll(sessions);
/*     */     }
/*     */     
/* 322 */     Collections.sort(sessionList, sessionComparator);
/* 323 */     this.sessionLocator.updateSessions(sessionList);
/*     */   }
/*     */   
/*     */   public synchronized void removeSession(Session session) {
/* 327 */     MemcachedTCPSession tcpSession = (MemcachedTCPSession)session;
/* 328 */     InetSocketAddressWrapper addrWrapper = tcpSession.getInetSocketAddressWrapper();
/*     */     
/* 330 */     InetSocketAddress mainNodeAddr = addrWrapper.getMainNodeAddress();
/* 331 */     if (mainNodeAddr != null) {
/* 332 */       removeStandbySession(session, mainNodeAddr);
/*     */     } else {
/* 334 */       removeMainSession(session);
/*     */     }
/*     */   }
/*     */   
/*     */   private void removeMainSession(Session session) {
/* 339 */     InetSocketAddress remoteSocketAddress = session.getRemoteSocketAddress();
/*     */     
/*     */ 
/* 342 */     if (this.failureMode) {
/* 343 */       log.warn("Client in failure mode,we don't remove session " + SystemUtils.getRawAddress(remoteSocketAddress) + ":" + remoteSocketAddress.getPort());
/*     */       
/*     */ 
/* 346 */       return;
/*     */     }
/* 348 */     log.warn("Remove a session: " + SystemUtils.getRawAddress(remoteSocketAddress) + ":" + remoteSocketAddress.getPort());
/*     */     
/*     */ 
/* 351 */     Queue<Session> sessionQueue = (Queue)this.sessionMap.get(session.getRemoteSocketAddress());
/*     */     
/* 353 */     if (null != sessionQueue) {
/* 354 */       sessionQueue.remove(session);
/* 355 */       if (sessionQueue.size() == 0) {
/* 356 */         this.sessionMap.remove(session.getRemoteSocketAddress());
/*     */       }
/* 358 */       updateSessions();
/*     */     }
/*     */   }
/*     */   
/*     */   private void removeStandbySession(Session session, InetSocketAddress mainNodeAddr)
/*     */   {
/* 364 */     List<Session> sessionList = (List)this.standbySessionMap.get(mainNodeAddr);
/* 365 */     if (null != sessionList) {
/* 366 */       sessionList.remove(session);
/* 367 */       if (sessionList.size() == 0) {
/* 368 */         this.standbySessionMap.remove(mainNodeAddr);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   protected void doStart() throws IOException
/*     */   {
/* 375 */     setLocalSocketAddress(new InetSocketAddress("localhost", 0));
/*     */   }
/*     */   
/*     */   public void onConnect(SelectionKey key) throws IOException
/*     */   {
/* 380 */     key.interestOps(key.interestOps() & 0xFFFFFFF7);
/* 381 */     ConnectFuture future = (ConnectFuture)key.attachment();
/* 382 */     if ((future == null) || (future.isCancelled())) {
/* 383 */       cancelKey(key);
/* 384 */       return;
/*     */     }
/*     */     try {
/* 387 */       if (!((SocketChannel)key.channel()).finishConnect()) {
/* 388 */         cancelKey(key);
/* 389 */         future.failure(new IOException("Connect to " + SystemUtils.getRawAddress(future.getInetSocketAddressWrapper().getInetSocketAddress()) + ":" + future.getInetSocketAddressWrapper().getInetSocketAddress().getPort() + " fail"));
/*     */ 
/*     */ 
/*     */       }
/*     */       else
/*     */       {
/*     */ 
/*     */ 
/* 397 */         key.attach(null);
/* 398 */         addSession(createSession((SocketChannel)key.channel(), future.getInetSocketAddressWrapper()));
/*     */         
/*     */ 
/* 401 */         future.setResult(Boolean.TRUE);
/*     */       }
/*     */     } catch (Exception e) {
/* 404 */       future.failure(e);
/* 405 */       cancelKey(key);
/* 406 */       throw new IOException("Connect to " + SystemUtils.getRawAddress(future.getInetSocketAddressWrapper().getInetSocketAddress()) + ":" + future.getInetSocketAddressWrapper().getInetSocketAddress().getPort() + " fail," + e.getMessage());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void cancelKey(SelectionKey key)
/*     */     throws IOException
/*     */   {
/*     */     try
/*     */     {
/* 419 */       if (key.channel() != null)
/* 420 */         key.channel().close();
/*     */     } finally {
/* 422 */       key.cancel();
/*     */     }
/*     */   }
/*     */   
/*     */   protected MemcachedTCPSession createSession(SocketChannel socketChannel, InetSocketAddressWrapper wrapper)
/*     */   {
/* 428 */     MemcachedTCPSession session = (MemcachedTCPSession)buildSession(socketChannel);
/*     */     
/* 430 */     session.setInetSocketAddressWrapper(wrapper);
/* 431 */     this.selectorManager.registerSession(session, EventType.ENABLE_READ);
/* 432 */     session.start();
/* 433 */     session.onEvent(EventType.CONNECTED, null);
/* 434 */     return session;
/*     */   }
/*     */   
/*     */   public void addToWatingQueue(ReconnectRequest request) {
/* 438 */     this.waitingQueue.add(request);
/*     */   }
/*     */   
/*     */   public Future<Boolean> connect(InetSocketAddressWrapper addressWrapper) throws IOException
/*     */   {
/* 443 */     if (addressWrapper == null) {
/* 444 */       throw new NullPointerException("Null Address");
/*     */     }
/*     */     
/* 447 */     this.removedAddrSet.remove(addressWrapper.getInetSocketAddress());
/* 448 */     SocketChannel socketChannel = null;
/*     */     try {
/* 450 */       socketChannel = SocketChannel.open();
/* 451 */       configureSocketChannel(socketChannel);
/* 452 */       ConnectFuture future = new ConnectFuture(addressWrapper);
/* 453 */       if (!socketChannel.connect(addressWrapper.getInetSocketAddress())) {
/* 454 */         this.selectorManager.registerChannel(socketChannel, 8, future);
/*     */       }
/*     */       else {
/* 457 */         addSession(createSession(socketChannel, addressWrapper));
/*     */         
/* 459 */         future.setResult(Boolean.valueOf(true));
/*     */       }
/* 461 */       return future;
/*     */     } catch (IOException e) {
/* 463 */       if (socketChannel != null) {
/* 464 */         socketChannel.close();
/*     */       }
/* 466 */       throw e;
/*     */     }
/*     */   }
/*     */   
/*     */   public void closeChannel(Selector selector)
/*     */     throws IOException
/*     */   {}
/*     */   
/* 474 */   private final Random random = new Random();
/*     */   
/*     */   public void send(Command msg) throws MemcachedException {
/* 477 */     MemcachedSession session = (MemcachedSession)findSessionByKey(msg.getKey());
/*     */     
/* 479 */     if (session == null) {
/* 480 */       throw new MemcachedException("There is no available connection at this moment");
/*     */     }
/*     */     
/*     */ 
/* 484 */     if (session.isClosed()) {
/* 485 */       session = findStandbySession(session);
/*     */     }
/* 487 */     if (session.isClosed()) {
/* 488 */       throw new MemcachedException("Session(" + SystemUtils.getRawAddress(session.getRemoteSocketAddress()) + ":" + session.getRemoteSocketAddress().getPort() + ") has been closed");
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 494 */     if (session.isAuthFailed()) {
/* 495 */       throw new MemcachedException("Auth failed to connection " + session.getRemoteSocketAddress());
/*     */     }
/*     */     
/* 498 */     session.write(msg);
/*     */   }
/*     */   
/*     */   private MemcachedSession findStandbySession(MemcachedSession session) {
/* 502 */     if (this.failureMode) {
/* 503 */       List<Session> sessionList = getStandbySessionListByMainNodeAddr(session.getRemoteSocketAddress());
/*     */       
/*     */ 
/* 506 */       if ((sessionList != null) && (!sessionList.isEmpty())) {
/* 507 */         return (MemcachedTCPSession)sessionList.get(this.random.nextInt(sessionList.size()));
/*     */       }
/*     */     }
/*     */     
/* 511 */     return session;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public List<Session> getStandbySessionListByMainNodeAddr(InetSocketAddress addr)
/*     */   {
/* 522 */     return (List)this.standbySessionMap.get(addr);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   class InnerControllerStateListener
/*     */     implements ControllerStateListener
/*     */   {
/* 532 */     private final MemcachedConnector.SessionMonitor sessionMonitor = new MemcachedConnector.SessionMonitor(MemcachedConnector.this);
/*     */     
/*     */     InnerControllerStateListener() {}
/*     */     
/*     */     public void onAllSessionClosed(Controller controller) {}
/*     */     
/*     */     public void onException(Controller controller, Throwable t) {
/* 539 */       MemcachedConnector.log.error("Exception occured in controller", t);
/*     */     }
/*     */     
/*     */     public void onReady(Controller controller) {
/* 543 */       this.sessionMonitor.start();
/*     */     }
/*     */     
/*     */ 
/*     */     public void onStarted(Controller controller) {}
/*     */     
/*     */     public void onStopped(Controller controller)
/*     */     {
/* 551 */       this.sessionMonitor.interrupt();
/*     */     }
/*     */   }
/*     */   
/*     */   public final Session findSessionByKey(String key)
/*     */   {
/* 557 */     return this.sessionLocator.getSessionByKey(key);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final Queue<Session> getSessionByAddress(InetSocketAddress addr)
/*     */   {
/* 567 */     return (Queue)this.sessionMap.get(addr);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public MemcachedConnector(Configuration configuration, MemcachedSessionLocator locator, BufferAllocator allocator, CommandFactory commandFactory, int poolSize, int maxQueuedNoReplyOperations)
/*     */   {
/* 574 */     super(configuration, null);
/* 575 */     this.sessionLocator = locator;
/* 576 */     this.protocol = commandFactory.getProtocol();
/* 577 */     addStateListener(new InnerControllerStateListener());
/* 578 */     updateSessions();
/* 579 */     this.bufferAllocator = allocator;
/* 580 */     this.optimiezer = new Optimizer(this.protocol);
/* 581 */     this.optimiezer.setBufferAllocator(this.bufferAllocator);
/* 582 */     this.connectionPoolSize = poolSize;
/* 583 */     this.soLingerOn = true;
/* 584 */     this.commandFactory = commandFactory;
/* 585 */     this.flowControl = new FlowControl(maxQueuedNoReplyOperations);
/* 586 */     setSelectorPoolSize(2 * Runtime.getRuntime().availableProcessors());
/*     */   }
/*     */   
/*     */ 
/*     */   public final void setConnectionPoolSize(int poolSize)
/*     */   {
/* 592 */     this.connectionPoolSize = poolSize;
/*     */   }
/*     */   
/*     */   public void setMergeFactor(int mergeFactor) {
/* 596 */     ((OptimizerMBean)this.optimiezer).setMergeFactor(mergeFactor);
/*     */   }
/*     */   
/*     */   public FlowControl getNoReplyOpsFlowControl() {
/* 600 */     return this.flowControl;
/*     */   }
/*     */   
/*     */   protected NioSession buildSession(SocketChannel sc)
/*     */   {
/* 605 */     Queue<WriteMessage> queue = buildQueue();
/* 606 */     NioSessionConfig sessionCofig = buildSessionConfig(sc, queue);
/*     */     
/* 608 */     MemcachedTCPSession session = new MemcachedTCPSession(sessionCofig, this.configuration.getSessionReadBufferSize(), this.optimiezer, getReadThreadCount(), this.commandFactory);
/*     */     
/*     */ 
/* 611 */     session.setBufferAllocator(this.bufferAllocator);
/* 612 */     return session;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected Queue<WriteMessage> buildQueue()
/*     */   {
/* 622 */     return new FlowControlLinkedTransferQueue(this.flowControl);
/*     */   }
/*     */   
/*     */   public BufferAllocator getBufferAllocator() {
/* 626 */     return this.bufferAllocator;
/*     */   }
/*     */   
/*     */   public synchronized void quitAllSessions() {
/* 630 */     for (Session session : this.sessionSet) {
/* 631 */       ((MemcachedSession)session).quit();
/*     */     }
/* 633 */     int sleepCount = 0;
/* 634 */     while ((sleepCount++ < 5) && (this.sessionSet.size() > 0)) {
/*     */       try {
/* 636 */         wait(1000L);
/*     */       } catch (InterruptedException e) {
/* 638 */         Thread.currentThread().interrupt();
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public void setFailureMode(boolean failureMode)
/*     */   {
/* 645 */     this.failureMode = failureMode;
/*     */   }
/*     */   
/*     */   public void setBufferAllocator(BufferAllocator allocator) {
/* 649 */     this.bufferAllocator = allocator;
/* 650 */     for (Session session : getSessionSet()) {
/* 651 */       ((MemcachedSession)session).setBufferAllocator(allocator);
/*     */     }
/*     */   }
/*     */   
/*     */   public Collection<InetSocketAddress> getServerAddresses() {
/* 656 */     return Collections.unmodifiableCollection(this.sessionMap.keySet());
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\impl\MemcachedConnector.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */