/*     */ package org.codehaus.jackson.impl;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.Reader;
/*     */ import org.codehaus.jackson.JsonParseException;
/*     */ import org.codehaus.jackson.JsonParser.Feature;
/*     */ import org.codehaus.jackson.JsonToken;
/*     */ import org.codehaus.jackson.io.IOContext;
/*     */ import org.codehaus.jackson.util.TextBuffer;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class ReaderBasedNumericParser
/*     */   extends ReaderBasedParserBase
/*     */ {
/*     */   public ReaderBasedNumericParser(IOContext pc, int features, Reader r)
/*     */   {
/*  28 */     super(pc, features, r);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final JsonToken parseNumberText(int ch)
/*     */     throws IOException, JsonParseException
/*     */   {
/*  60 */     boolean negative = ch == 45;
/*  61 */     int ptr = this._inputPtr;
/*  62 */     int startPtr = ptr - 1;
/*  63 */     int inputLen = this._inputEnd;
/*     */     
/*     */ 
/*     */ 
/*  67 */     if (negative) {
/*  68 */       if (ptr >= this._inputEnd) {
/*     */         break label347;
/*     */       }
/*  71 */       ch = this._inputBuffer[(ptr++)];
/*     */       
/*  73 */       if ((ch > 57) || (ch < 48)) {
/*  74 */         this._inputPtr = ptr;
/*  75 */         return _handleInvalidNumberStart(ch, true);
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  83 */     if (ch != 48)
/*     */     {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  93 */       int intLen = 1;
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  99 */       while (ptr < this._inputEnd)
/*     */       {
/*     */ 
/* 102 */         ch = this._inputBuffer[(ptr++)];
/* 103 */         if ((ch >= 48) && (ch <= 57))
/*     */         {
/*     */ 
/* 106 */           intLen++;
/*     */         }
/*     */         else {
/* 109 */           int fractLen = 0;
/*     */           
/*     */ 
/* 112 */           if (ch == 46)
/*     */           {
/*     */             for (;;) {
/* 115 */               if (ptr >= inputLen) {
/*     */                 break label347;
/*     */               }
/* 118 */               ch = this._inputBuffer[(ptr++)];
/* 119 */               if ((ch < 48) || (ch > 57)) {
/*     */                 break;
/*     */               }
/* 122 */               fractLen++;
/*     */             }
/*     */             
/* 125 */             if (fractLen == 0) {
/* 126 */               reportUnexpectedNumberChar(ch, "Decimal point not followed by a digit");
/*     */             }
/*     */           }
/*     */           
/* 130 */           int expLen = 0;
/* 131 */           if ((ch == 101) || (ch == 69)) {
/* 132 */             if (ptr >= inputLen) {
/*     */               break;
/*     */             }
/*     */             
/* 136 */             ch = this._inputBuffer[(ptr++)];
/* 137 */             if ((ch == 45) || (ch == 43)) {
/* 138 */               if (ptr >= inputLen) {
/*     */                 break;
/*     */               }
/* 141 */               ch = this._inputBuffer[(ptr++)];
/*     */             }
/* 143 */             while ((ch <= 57) && (ch >= 48)) {
/* 144 */               expLen++;
/* 145 */               if (ptr >= inputLen) {
/*     */                 break label347;
/*     */               }
/* 148 */               ch = this._inputBuffer[(ptr++)];
/*     */             }
/*     */             
/* 151 */             if (expLen == 0) {
/* 152 */               reportUnexpectedNumberChar(ch, "Exponent indicator not followed by a digit");
/*     */             }
/*     */           }
/*     */           
/*     */ 
/* 157 */           ptr--;
/* 158 */           this._inputPtr = ptr;
/* 159 */           int len = ptr - startPtr;
/* 160 */           this._textBuffer.resetWithShared(this._inputBuffer, startPtr, len);
/* 161 */           return reset(negative, intLen, fractLen, expLen);
/*     */         } } }
/*     */     label347:
/* 164 */     this._inputPtr = (negative ? startPtr + 1 : startPtr);
/* 165 */     return parseNumberText2(negative);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private final JsonToken parseNumberText2(boolean negative)
/*     */     throws IOException, JsonParseException
/*     */   {
/* 178 */     char[] outBuf = this._textBuffer.emptyAndGetCurrentSegment();
/* 179 */     int outPtr = 0;
/*     */     
/*     */ 
/* 182 */     if (negative) {
/* 183 */       outBuf[(outPtr++)] = '-';
/*     */     }
/*     */     
/*     */ 
/* 187 */     int intLen = 0;
/* 188 */     char c = this._inputPtr < this._inputEnd ? this._inputBuffer[(this._inputPtr++)] : getNextChar("No digit following minus sign");
/* 189 */     if (c == '0') {
/* 190 */       c = _verifyNoLeadingZeroes();
/*     */     }
/* 192 */     boolean eof = false;
/*     */     
/*     */ 
/*     */ 
/* 196 */     while ((c >= '0') && (c <= '9')) {
/* 197 */       intLen++;
/* 198 */       if (outPtr >= outBuf.length) {
/* 199 */         outBuf = this._textBuffer.finishCurrentSegment();
/* 200 */         outPtr = 0;
/*     */       }
/* 202 */       outBuf[(outPtr++)] = c;
/* 203 */       if ((this._inputPtr >= this._inputEnd) && (!loadMore()))
/*     */       {
/* 205 */         c = '\000';
/* 206 */         eof = true;
/* 207 */         break;
/*     */       }
/* 209 */       c = this._inputBuffer[(this._inputPtr++)];
/*     */     }
/*     */     
/* 212 */     if (intLen == 0) {
/* 213 */       reportInvalidNumber("Missing integer part (next char " + _getCharDesc(c) + ")");
/*     */     }
/*     */     
/* 216 */     int fractLen = 0;
/*     */     
/* 218 */     if (c == '.') {
/* 219 */       outBuf[(outPtr++)] = c;
/*     */       
/*     */       for (;;)
/*     */       {
/* 223 */         if ((this._inputPtr >= this._inputEnd) && (!loadMore())) {
/* 224 */           eof = true;
/* 225 */           break;
/*     */         }
/* 227 */         c = this._inputBuffer[(this._inputPtr++)];
/* 228 */         if ((c < '0') || (c > '9')) {
/*     */           break;
/*     */         }
/* 231 */         fractLen++;
/* 232 */         if (outPtr >= outBuf.length) {
/* 233 */           outBuf = this._textBuffer.finishCurrentSegment();
/* 234 */           outPtr = 0;
/*     */         }
/* 236 */         outBuf[(outPtr++)] = c;
/*     */       }
/*     */       
/* 239 */       if (fractLen == 0) {
/* 240 */         reportUnexpectedNumberChar(c, "Decimal point not followed by a digit");
/*     */       }
/*     */     }
/*     */     
/* 244 */     int expLen = 0;
/* 245 */     if ((c == 'e') || (c == 'E')) {
/* 246 */       if (outPtr >= outBuf.length) {
/* 247 */         outBuf = this._textBuffer.finishCurrentSegment();
/* 248 */         outPtr = 0;
/*     */       }
/* 250 */       outBuf[(outPtr++)] = c;
/*     */       
/* 252 */       c = this._inputPtr < this._inputEnd ? this._inputBuffer[(this._inputPtr++)] : getNextChar("expected a digit for number exponent");
/*     */       
/*     */ 
/* 255 */       if ((c == '-') || (c == '+')) {
/* 256 */         if (outPtr >= outBuf.length) {
/* 257 */           outBuf = this._textBuffer.finishCurrentSegment();
/* 258 */           outPtr = 0;
/*     */         }
/* 260 */         outBuf[(outPtr++)] = c;
/*     */         
/* 262 */         c = this._inputPtr < this._inputEnd ? this._inputBuffer[(this._inputPtr++)] : getNextChar("expected a digit for number exponent");
/*     */       }
/*     */       
/*     */ 
/*     */ 
/* 267 */       while ((c <= '9') && (c >= '0')) {
/* 268 */         expLen++;
/* 269 */         if (outPtr >= outBuf.length) {
/* 270 */           outBuf = this._textBuffer.finishCurrentSegment();
/* 271 */           outPtr = 0;
/*     */         }
/* 273 */         outBuf[(outPtr++)] = c;
/* 274 */         if ((this._inputPtr >= this._inputEnd) && (!loadMore())) {
/* 275 */           eof = true;
/* 276 */           break;
/*     */         }
/* 278 */         c = this._inputBuffer[(this._inputPtr++)];
/*     */       }
/*     */       
/* 281 */       if (expLen == 0) {
/* 282 */         reportUnexpectedNumberChar(c, "Exponent indicator not followed by a digit");
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 287 */     if (!eof) {
/* 288 */       this._inputPtr -= 1;
/*     */     }
/* 290 */     this._textBuffer.setCurrentLength(outPtr);
/*     */     
/* 292 */     return reset(negative, intLen, fractLen, expLen);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private final char _verifyNoLeadingZeroes()
/*     */     throws IOException, JsonParseException
/*     */   {
/* 303 */     if ((this._inputPtr >= this._inputEnd) && (!loadMore())) {
/* 304 */       return '0';
/*     */     }
/* 306 */     char ch = this._inputBuffer[this._inputPtr];
/*     */     
/* 308 */     if ((ch < '0') || (ch > '9')) {
/* 309 */       return '0';
/*     */     }
/* 311 */     if (!isEnabled(JsonParser.Feature.ALLOW_NUMERIC_LEADING_ZEROS)) {
/* 312 */       reportInvalidNumber("Leading zeroes not allowed");
/*     */     }
/*     */     
/* 315 */     this._inputPtr += 1;
/* 316 */     if (ch == '0') {
/* 317 */       while ((this._inputPtr < this._inputEnd) || (loadMore())) {
/* 318 */         ch = this._inputBuffer[this._inputPtr];
/* 319 */         if ((ch < '0') || (ch > '9')) {
/* 320 */           return '0';
/*     */         }
/* 322 */         this._inputPtr += 1;
/* 323 */         if (ch != '0') {
/*     */           break;
/*     */         }
/*     */       }
/*     */     }
/* 328 */     return ch;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected JsonToken _handleInvalidNumberStart(int ch, boolean negative)
/*     */     throws IOException, JsonParseException
/*     */   {
/* 338 */     if (ch == 73) {
/* 339 */       if ((this._inputPtr >= this._inputEnd) && 
/* 340 */         (!loadMore())) {
/* 341 */         _reportInvalidEOFInValue();
/*     */       }
/*     */       
/* 344 */       ch = this._inputBuffer[(this._inputPtr++)];
/* 345 */       if (ch == 78) {
/* 346 */         String match = negative ? "-INF" : "+INF";
/* 347 */         if (_matchToken(match, 3)) {
/* 348 */           if (isEnabled(JsonParser.Feature.ALLOW_NON_NUMERIC_NUMBERS)) {
/* 349 */             return resetAsNaN(match, negative ? Double.NEGATIVE_INFINITY : Double.POSITIVE_INFINITY);
/*     */           }
/* 351 */           _reportError("Non-standard token '" + match + "': enable JsonParser.Feature.ALLOW_NON_NUMERIC_NUMBERS to allow");
/*     */         }
/* 353 */       } else if (ch == 110) {
/* 354 */         String match = negative ? "-Infinity" : "+Infinity";
/* 355 */         if (_matchToken(match, 3)) {
/* 356 */           if (isEnabled(JsonParser.Feature.ALLOW_NON_NUMERIC_NUMBERS)) {
/* 357 */             return resetAsNaN(match, negative ? Double.NEGATIVE_INFINITY : Double.POSITIVE_INFINITY);
/*     */           }
/* 359 */           _reportError("Non-standard token '" + match + "': enable JsonParser.Feature.ALLOW_NON_NUMERIC_NUMBERS to allow");
/*     */         }
/*     */       }
/*     */     }
/* 363 */     reportUnexpectedNumberChar(ch, "expected digit (0-9) to follow minus sign, for valid numeric value");
/* 364 */     return null;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\impl\ReaderBasedNumericParser.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */