/*    */ package com.sun.xml.bind.v2.runtime.reflect;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import java.util.Map;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class PrimitiveArrayListerInteger<BeanT>
/*    */   extends Lister<BeanT, int[], Integer, IntegerArrayPack>
/*    */ {
/*    */   static void register()
/*    */   {
/* 19 */     Lister.primitiveArrayListers.put(Integer.TYPE, new PrimitiveArrayListerInteger());
/*    */   }
/*    */   
/*    */   public ListIterator<Integer> iterator(final int[] objects, XMLSerializer context) {
/* 23 */     new ListIterator() {
/* 24 */       int idx = 0;
/*    */       
/* 26 */       public boolean hasNext() { return this.idx < objects.length; }
/*    */       
/*    */       public Integer next()
/*    */       {
/* 30 */         return Integer.valueOf(objects[(this.idx++)]);
/*    */       }
/*    */     };
/*    */   }
/*    */   
/*    */   public IntegerArrayPack startPacking(BeanT current, Accessor<BeanT, int[]> acc) {
/* 36 */     return new IntegerArrayPack();
/*    */   }
/*    */   
/*    */   public void addToPack(IntegerArrayPack objects, Integer o) {
/* 40 */     objects.add(o);
/*    */   }
/*    */   
/*    */   public void endPacking(IntegerArrayPack pack, BeanT bean, Accessor<BeanT, int[]> acc) throws AccessorException {
/* 44 */     acc.set(bean, pack.build());
/*    */   }
/*    */   
/*    */   public void reset(BeanT o, Accessor<BeanT, int[]> acc) throws AccessorException {
/* 48 */     acc.set(o, new int[0]);
/*    */   }
/*    */   
/*    */   static final class IntegerArrayPack {
/* 52 */     int[] buf = new int[16];
/*    */     int size;
/*    */     
/*    */     void add(Integer b) {
/* 56 */       if (this.buf.length == this.size)
/*    */       {
/* 58 */         int[] nb = new int[this.buf.length * 2];
/* 59 */         System.arraycopy(this.buf, 0, nb, 0, this.buf.length);
/* 60 */         this.buf = nb;
/*    */       }
/* 62 */       this.buf[(this.size++)] = b.intValue();
/*    */     }
/*    */     
/*    */     int[] build() {
/* 66 */       if (this.buf.length == this.size)
/*    */       {
/* 68 */         return this.buf;
/*    */       }
/* 70 */       int[] r = new int[this.size];
/* 71 */       System.arraycopy(this.buf, 0, r, 0, this.size);
/* 72 */       return r;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\PrimitiveArrayListerInteger.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */