package net.rubyeye.xmemcached;

import com.google.code.yanf4j.config.Configuration;
import com.google.code.yanf4j.core.SocketOption;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.util.List;
import java.util.Map;
import net.rubyeye.xmemcached.auth.AuthInfo;
import net.rubyeye.xmemcached.buffer.BufferAllocator;
import net.rubyeye.xmemcached.transcoders.Transcoder;

public abstract interface MemcachedClientBuilder
{
  public abstract MemcachedSessionLocator getSessionLocator();
  
  public abstract void setSessionLocator(MemcachedSessionLocator paramMemcachedSessionLocator);
  
  public abstract BufferAllocator getBufferAllocator();
  
  public abstract void setBufferAllocator(BufferAllocator paramBufferAllocator);
  
  public abstract Configuration getConfiguration();
  
  public abstract void setConfiguration(Configuration paramConfiguration);
  
  public abstract MemcachedClient build()
    throws IOException;
  
  public abstract void setConnectionPoolSize(int paramInt);
  
  public abstract Transcoder getTranscoder();
  
  public abstract void setTranscoder(Transcoder paramTranscoder);
  
  public abstract CommandFactory getCommandFactory();
  
  public abstract void addStateListener(MemcachedClientStateListener paramMemcachedClientStateListener);
  
  public abstract void removeStateListener(MemcachedClientStateListener paramMemcachedClientStateListener);
  
  public abstract void setStateListeners(List<MemcachedClientStateListener> paramList);
  
  public abstract void setCommandFactory(CommandFactory paramCommandFactory);
  
  public abstract void setSocketOption(SocketOption paramSocketOption, Object paramObject);
  
  public abstract Map<SocketOption, Object> getSocketOptions();
  
  public abstract void setAuthInfoMap(Map<InetSocketAddress, AuthInfo> paramMap);
  
  public abstract Map<InetSocketAddress, AuthInfo> getAuthInfoMap();
  
  public abstract void addAuthInfo(InetSocketAddress paramInetSocketAddress, AuthInfo paramAuthInfo);
  
  public abstract void removeAuthInfo(InetSocketAddress paramInetSocketAddress);
  
  public abstract String getName();
  
  public abstract void setName(String paramString);
  
  public abstract void setFailureMode(boolean paramBoolean);
  
  public abstract boolean isFailureMode();
  
  public abstract long getConnectTimeout();
  
  public abstract void setConnectTimeout(long paramLong);
  
  public abstract void setSanitizeKeys(boolean paramBoolean);
  
  public abstract void setKeyProvider(KeyProvider paramKeyProvider);
  
  public abstract void setMaxQueuedNoReplyOperations(int paramInt);
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\MemcachedClientBuilder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */