/*    */ package net.rubyeye.xmemcached.command.text;
/*    */ 
/*    */ import com.google.code.yanf4j.buffer.IoBuffer;
/*    */ import java.nio.ByteBuffer;
/*    */ import java.util.concurrent.CountDownLatch;
/*    */ import net.rubyeye.xmemcached.command.VerbosityCommand;
/*    */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*    */ import net.rubyeye.xmemcached.monitor.Constants;
/*    */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class TextVerbosityCommand
/*    */   extends VerbosityCommand
/*    */ {
/*    */   public static final String VERBOSITY = "verbosity";
/*    */   
/*    */   public TextVerbosityCommand(CountDownLatch latch, int level, boolean noreply)
/*    */   {
/* 46 */     super(latch, level, noreply);
/*    */   }
/*    */   
/*    */ 
/*    */   public boolean decode(MemcachedTCPSession session, ByteBuffer buffer)
/*    */   {
/* 52 */     if ((buffer == null) || (!buffer.hasRemaining())) {
/* 53 */       return false;
/*    */     }
/* 55 */     if (this.result == null) {
/* 56 */       byte first = buffer.get(buffer.position());
/* 57 */       if (first == 79) {
/* 58 */         setResult(Boolean.TRUE);
/* 59 */         countDownLatch();
/*    */         
/* 61 */         return ByteUtils.stepBuffer(buffer, 4);
/*    */       }
/* 63 */       return decodeError(session, buffer);
/*    */     }
/*    */     
/* 66 */     return ByteUtils.stepBuffer(buffer, 4);
/*    */   }
/*    */   
/*    */ 
/*    */   public void encode()
/*    */   {
/* 72 */     byte[] levelBytes = ByteUtils.getBytes(String.valueOf(this.level));
/*    */     
/* 74 */     if (isNoreply()) {
/* 75 */       this.ioBuffer = IoBuffer.allocate(4 + "verbosity".length() + levelBytes.length + Constants.NO_REPLY.length);
/*    */       
/* 77 */       ByteUtils.setArguments(this.ioBuffer, new Object[] { "verbosity", levelBytes, Constants.NO_REPLY });
/*    */     }
/*    */     else {
/* 80 */       this.ioBuffer = IoBuffer.allocate(3 + "verbosity".length() + levelBytes.length);
/*    */       
/* 82 */       ByteUtils.setArguments(this.ioBuffer, new Object[] { "verbosity", levelBytes });
/*    */     }
/*    */     
/* 85 */     this.ioBuffer.flip();
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\text\TextVerbosityCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */