/*    */ package org.apache.avro.io.parsing;
/*    */ 
/*    */ import java.util.HashMap;
/*    */ import java.util.List;
/*    */ import java.util.Map;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.Schema.Field;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class JsonGrammarGenerator
/*    */   extends ValidatingGrammarGenerator
/*    */ {
/*    */   public Symbol generate(Schema schema)
/*    */   {
/* 37 */     return Symbol.root(new Symbol[] { generate(schema, new HashMap()) });
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public Symbol generate(Schema sc, Map<ValidatingGrammarGenerator.LitS, Symbol> seen)
/*    */   {
/* 51 */     switch (sc.getType()) {
/*    */     case NULL: 
/*    */     case BOOLEAN: 
/*    */     case INT: 
/*    */     case LONG: 
/*    */     case FLOAT: 
/*    */     case DOUBLE: 
/*    */     case STRING: 
/*    */     case BYTES: 
/*    */     case FIXED: 
/*    */     case UNION: 
/* 62 */       return super.generate(sc, seen);
/*    */     case ENUM: 
/* 64 */       return Symbol.seq(new Symbol[] { new Symbol.EnumLabelsAction(sc.getEnumSymbols()), Symbol.ENUM });
/*    */     
/*    */     case ARRAY: 
/* 67 */       return Symbol.seq(new Symbol[] { Symbol.repeat(Symbol.ARRAY_END, new Symbol[] { Symbol.ITEM_END, generate(sc.getElementType(), seen) }), Symbol.ARRAY_START });
/*    */     
/*    */ 
/*    */     case MAP: 
/* 71 */       return Symbol.seq(new Symbol[] { Symbol.repeat(Symbol.MAP_END, new Symbol[] { Symbol.ITEM_END, generate(sc.getValueType(), seen), Symbol.MAP_KEY_MARKER, Symbol.STRING }), Symbol.MAP_START });
/*    */     
/*    */ 
/*    */ 
/*    */     case RECORD: 
/* 76 */       ValidatingGrammarGenerator.LitS wsc = new ValidatingGrammarGenerator.LitS(sc);
/* 77 */       Symbol rresult = (Symbol)seen.get(wsc);
/* 78 */       if (rresult == null) {
/* 79 */         Symbol[] production = new Symbol[sc.getFields().size() * 3 + 2];
/* 80 */         rresult = Symbol.seq(production);
/* 81 */         seen.put(wsc, rresult);
/*    */         
/* 83 */         int i = production.length;
/* 84 */         int n = 0;
/* 85 */         production[(--i)] = Symbol.RECORD_START;
/* 86 */         for (Schema.Field f : sc.getFields()) {
/* 87 */           production[(--i)] = new Symbol.FieldAdjustAction(n, f.name());
/* 88 */           production[(--i)] = generate(f.schema(), seen);
/* 89 */           production[(--i)] = Symbol.FIELD_END;
/* 90 */           n++;
/*    */         }
/* 92 */         production[(--i)] = Symbol.RECORD_END;
/*    */       }
/* 94 */       return rresult;
/*    */     }
/*    */     
/* 97 */     throw new RuntimeException("Unexpected schema type");
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\io\parsing\JsonGrammarGenerator.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */