/*     */ package org.apache.avro.specific;
/*     */ 
/*     */ import java.lang.reflect.Constructor;
/*     */ import org.apache.avro.Schema;
/*     */ import org.apache.avro.data.ErrorBuilder;
/*     */ import org.apache.avro.data.RecordBuilderBase;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class SpecificErrorBuilderBase<T extends SpecificExceptionBase>
/*     */   extends RecordBuilderBase<T>
/*     */   implements ErrorBuilder<T>
/*     */ {
/*     */   private Constructor<T> errorConstructor;
/*     */   private Object value;
/*     */   private boolean hasValue;
/*     */   private Throwable cause;
/*     */   private boolean hasCause;
/*     */   
/*     */   protected SpecificErrorBuilderBase(Schema schema)
/*     */   {
/*  43 */     super(schema, SpecificData.get());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected SpecificErrorBuilderBase(SpecificErrorBuilderBase<T> other)
/*     */   {
/*  51 */     super(other, SpecificData.get());
/*  52 */     this.errorConstructor = other.errorConstructor;
/*  53 */     this.value = other.value;
/*  54 */     this.hasValue = other.hasValue;
/*  55 */     this.cause = other.cause;
/*  56 */     this.hasCause = other.hasCause;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected SpecificErrorBuilderBase(T other)
/*     */   {
/*  64 */     super(other.getSchema(), SpecificData.get());
/*     */     
/*  66 */     Object otherValue = other.getValue();
/*  67 */     if (otherValue != null) {
/*  68 */       setValue(otherValue);
/*     */     }
/*     */     
/*  71 */     Throwable otherCause = other.getCause();
/*  72 */     if (otherCause != null) {
/*  73 */       setCause(otherCause);
/*     */     }
/*     */   }
/*     */   
/*     */   public Object getValue()
/*     */   {
/*  79 */     return this.value;
/*     */   }
/*     */   
/*     */   public SpecificErrorBuilderBase<T> setValue(Object value)
/*     */   {
/*  84 */     this.value = value;
/*  85 */     this.hasValue = true;
/*  86 */     return this;
/*     */   }
/*     */   
/*     */   public boolean hasValue()
/*     */   {
/*  91 */     return this.hasValue;
/*     */   }
/*     */   
/*     */   public SpecificErrorBuilderBase<T> clearValue()
/*     */   {
/*  96 */     this.value = null;
/*  97 */     this.hasValue = false;
/*  98 */     return this;
/*     */   }
/*     */   
/*     */   public Throwable getCause()
/*     */   {
/* 103 */     return this.cause;
/*     */   }
/*     */   
/*     */   public SpecificErrorBuilderBase<T> setCause(Throwable cause)
/*     */   {
/* 108 */     this.cause = cause;
/* 109 */     this.hasCause = true;
/* 110 */     return this;
/*     */   }
/*     */   
/*     */   public boolean hasCause()
/*     */   {
/* 115 */     return this.hasCause;
/*     */   }
/*     */   
/*     */   public SpecificErrorBuilderBase<T> clearCause()
/*     */   {
/* 120 */     this.cause = null;
/* 121 */     this.hasCause = false;
/* 122 */     return this;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\specific\SpecificErrorBuilderBase.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */