/*    */ package org.codehaus.janino.util.iterator;
/*    */ 
/*    */ import java.util.Iterator;
/*    */ import java.util.NoSuchElementException;
/*    */ import org.codehaus.janino.util.Producer;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ProducerIterator
/*    */   implements Iterator
/*    */ {
/*    */   private final Producer producer;
/* 43 */   private static final Object UNKNOWN = new Object();
/* 44 */   private static final Object AT_END = null;
/* 45 */   private Object nextElement = UNKNOWN;
/*    */   
/*    */   public ProducerIterator(Producer producer) {
/* 48 */     this.producer = producer;
/*    */   }
/*    */   
/*    */   public boolean hasNext() {
/* 52 */     if (this.nextElement == UNKNOWN) this.nextElement = this.producer.produce();
/* 53 */     return this.nextElement != AT_END;
/*    */   }
/*    */   
/*    */   public Object next() {
/* 57 */     if (this.nextElement == UNKNOWN) this.nextElement = this.producer.produce();
/* 58 */     if (this.nextElement == AT_END) throw new NoSuchElementException();
/* 59 */     Object result = this.nextElement;
/* 60 */     this.nextElement = UNKNOWN;
/* 61 */     return result;
/*    */   }
/*    */   
/*    */   public void remove() {
/* 65 */     throw new UnsupportedOperationException("remove");
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\iterator\ProducerIterator.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */