/*    */ package org.hibernate.annotations.common.reflection.java;
/*    */ 
/*    */ import java.lang.reflect.ParameterizedType;
/*    */ import java.lang.reflect.Type;
/*    */ import java.util.Collection;
/*    */ import java.util.Map;
/*    */ import java.util.SortedMap;
/*    */ import org.hibernate.annotations.common.reflection.XClass;
/*    */ import org.hibernate.annotations.common.reflection.java.generics.TypeEnvironment;
/*    */ import org.hibernate.annotations.common.reflection.java.generics.TypeSwitch;
/*    */ import org.hibernate.annotations.common.reflection.java.generics.TypeUtils;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ class JavaXCollectionType
/*    */   extends JavaXType
/*    */ {
/*    */   public JavaXCollectionType(Type type, TypeEnvironment context, JavaReflectionManager factory)
/*    */   {
/* 21 */     super(type, context, factory);
/*    */   }
/*    */   
/*    */   public boolean isArray() {
/* 25 */     return false;
/*    */   }
/*    */   
/*    */   public boolean isCollection() {
/* 29 */     return true;
/*    */   }
/*    */   
/*    */   public XClass getElementClass() {
/* 33 */     (XClass)new TypeSwitch()
/*    */     {
/*    */       public XClass caseParameterizedType(ParameterizedType parameterizedType) {
/* 36 */         Type[] args = parameterizedType.getActualTypeArguments();
/*    */         
/* 38 */         Class<? extends Collection> collectionClass = JavaXCollectionType.this.getCollectionClass();
/* 39 */         Type componentType; Type componentType; if ((collectionClass.isAssignableFrom(Map.class)) || (collectionClass.isAssignableFrom(SortedMap.class)))
/*    */         {
/* 41 */           componentType = args[1];
/*    */         }
/*    */         else {
/* 44 */           componentType = args[0];
/*    */         }
/* 46 */         return JavaXCollectionType.this.toXClass(componentType); } }.doSwitch(approximate());
/*    */   }
/*    */   
/*    */ 
/*    */   public XClass getMapKey()
/*    */   {
/* 52 */     (XClass)new TypeSwitch()
/*    */     {
/*    */       public XClass caseParameterizedType(ParameterizedType parameterizedType) {
/* 55 */         if (JavaXCollectionType.this.getCollectionClass().isAssignableFrom(Map.class)) {
/* 56 */           return JavaXCollectionType.this.toXClass(parameterizedType.getActualTypeArguments()[0]);
/*    */         }
/* 58 */         return null; } }.doSwitch(approximate());
/*    */   }
/*    */   
/*    */ 
/*    */   public XClass getClassOrElementClass()
/*    */   {
/* 64 */     return toXClass(approximate());
/*    */   }
/*    */   
/*    */   public Class<? extends Collection> getCollectionClass() {
/* 68 */     return TypeUtils.getCollectionClass(approximate());
/*    */   }
/*    */   
/*    */   public XClass getType() {
/* 72 */     return toXClass(approximate());
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/JavaXCollectionType.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */