package prefuse.controls;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.util.EventListener;
import prefuse.visual.VisualItem;

public abstract interface Control
  extends EventListener, MouseListener, MouseMotionListener, MouseWheelListener, KeyListener
{
  public static final int LEFT_MOUSE_BUTTON = 16;
  public static final int MIDDLE_MOUSE_BUTTON = 8;
  public static final int RIGHT_MOUSE_BUTTON = 4;
  
  public abstract boolean isEnabled();
  
  public abstract void setEnabled(boolean paramBoolean);
  
  public abstract void itemDragged(VisualItem paramVisualItem, MouseEvent paramMouseEvent);
  
  public abstract void itemMoved(VisualItem paramVisualItem, MouseEvent paramMouseEvent);
  
  public abstract void itemWheelMoved(VisualItem paramVisualItem, MouseWheelEvent paramMouseWheelEvent);
  
  public abstract void itemClicked(VisualItem paramVisualItem, MouseEvent paramMouseEvent);
  
  public abstract void itemPressed(VisualItem paramVisualItem, MouseEvent paramMouseEvent);
  
  public abstract void itemReleased(VisualItem paramVisualItem, MouseEvent paramMouseEvent);
  
  public abstract void itemEntered(VisualItem paramVisualItem, MouseEvent paramMouseEvent);
  
  public abstract void itemExited(VisualItem paramVisualItem, MouseEvent paramMouseEvent);
  
  public abstract void itemKeyPressed(VisualItem paramVisualItem, KeyEvent paramKeyEvent);
  
  public abstract void itemKeyReleased(VisualItem paramVisualItem, KeyEvent paramKeyEvent);
  
  public abstract void itemKeyTyped(VisualItem paramVisualItem, KeyEvent paramKeyEvent);
  
  public abstract void mouseEntered(MouseEvent paramMouseEvent);
  
  public abstract void mouseExited(MouseEvent paramMouseEvent);
  
  public abstract void mousePressed(MouseEvent paramMouseEvent);
  
  public abstract void mouseReleased(MouseEvent paramMouseEvent);
  
  public abstract void mouseClicked(MouseEvent paramMouseEvent);
  
  public abstract void mouseDragged(MouseEvent paramMouseEvent);
  
  public abstract void mouseMoved(MouseEvent paramMouseEvent);
  
  public abstract void mouseWheelMoved(MouseWheelEvent paramMouseWheelEvent);
  
  public abstract void keyPressed(KeyEvent paramKeyEvent);
  
  public abstract void keyReleased(KeyEvent paramKeyEvent);
  
  public abstract void keyTyped(KeyEvent paramKeyEvent);
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\controls\Control.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */