package prefuse.data;

import java.util.BitSet;
import java.util.Iterator;
import java.util.LinkedList;
import prefuse.data.tuple.TupleManager;
import prefuse.visual.tuple.TableEdgeItem;

public class SpanningTree
  extends Tree
{
  public static final String SOURCE_EDGE = "source";
  protected static final Schema EDGE_SCHEMA = new Schema();
  protected Graph m_backing;
  
  public SpanningTree(Graph paramGraph, Node paramNode)
  {
    super(paramGraph.getNodeTable(), EDGE_SCHEMA.instantiate());
    this.m_backing = paramGraph;
    TupleManager local1 = new TupleManager(getEdgeTable(), null, TableEdgeItem.class)
    {
      public Tuple getTuple(int paramAnonymousInt)
      {
        return SpanningTree.this.m_backing.getEdge(this.m_table.getInt(paramAnonymousInt, "source"));
      }
    };
    getEdgeTable().setTupleManager(local1);
    super.setTupleManagers(paramGraph.m_nodeTuples, local1);
    buildSpanningTree(paramNode);
  }
  
  public void buildSpanningTree(Node paramNode)
  {
    super.clearEdges();
    super.setRoot(paramNode);
    LinkedList localLinkedList = new LinkedList();
    BitSet localBitSet = new BitSet();
    localLinkedList.add(paramNode);
    localBitSet.set(paramNode.getRow());
    Table localTable = getEdgeTable();
    while (!localLinkedList.isEmpty())
    {
      Node localNode1 = (Node)localLinkedList.removeFirst();
      Iterator localIterator = localNode1.edges();
      while (localIterator.hasNext())
      {
        Edge localEdge = (Edge)localIterator.next();
        Node localNode2 = localEdge.getAdjacentNode(localNode1);
        if (!localBitSet.get(localNode2.getRow()))
        {
          localLinkedList.add(localNode2);
          localBitSet.set(localNode2.getRow());
          int i = super.addChildEdge(localNode1.getRow(), localNode2.getRow());
          localTable.setInt(i, "source", localEdge.getRow());
        }
      }
    }
  }
  
  public int addChild(int paramInt)
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  public Node addChild(Node paramNode)
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  public int addChildEdge(int paramInt1, int paramInt2)
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  public Edge addChildEdge(Node paramNode1, Node paramNode2)
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  public Node addRoot()
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  public int addRootRow()
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  public boolean removeChild(int paramInt)
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  public boolean removeChild(Node paramNode)
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  public boolean removeChildEdge(Edge paramEdge)
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  public boolean removeChildEdge(int paramInt)
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  void setRoot(Node paramNode)
  {
    throw new UnsupportedOperationException("Changes to tree structure not allowed for spanning trees.");
  }
  
  public int addEdge(int paramInt1, int paramInt2)
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public Edge addEdge(Node paramNode1, Node paramNode2)
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public Node addNode()
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public int addNodeRow()
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public void clear()
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public boolean removeEdge(Edge paramEdge)
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public boolean removeEdge(int paramInt)
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public boolean removeNode(int paramInt)
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public boolean removeNode(Node paramNode)
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public boolean removeTuple(Tuple paramTuple)
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public void setEdgeTable(Table paramTable)
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  public void setTupleManagers(TupleManager paramTupleManager1, TupleManager paramTupleManager2)
  {
    throw new UnsupportedOperationException("Changes to graph structure not allowed for spanning trees.");
  }
  
  static
  {
    EDGE_SCHEMA.addColumn(DEFAULT_SOURCE_KEY, Integer.TYPE, new Integer(-1));
    EDGE_SCHEMA.addColumn(DEFAULT_TARGET_KEY, Integer.TYPE, new Integer(-1));
    EDGE_SCHEMA.addColumn("source", Integer.TYPE);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\SpanningTree.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */