package prefuse.util.display;

import java.awt.geom.Point2D;
import java.awt.geom.Point2D.Double;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Rectangle2D.Double;
import java.util.Iterator;
import prefuse.Display;
import prefuse.visual.VisualItem;

public class DisplayLib
{
  public static Rectangle2D getBounds(Iterator paramIterator, double paramDouble, Rectangle2D paramRectangle2D)
  {
    paramRectangle2D.setFrame(NaN.0D, NaN.0D, NaN.0D, NaN.0D);
    VisualItem localVisualItem;
    Rectangle2D localRectangle2D;
    if (paramIterator.hasNext())
    {
      localVisualItem = (VisualItem)paramIterator.next();
      localRectangle2D = localVisualItem.getBounds();
      paramRectangle2D.setFrame(localRectangle2D);
    }
    while (paramIterator.hasNext())
    {
      localVisualItem = (VisualItem)paramIterator.next();
      localRectangle2D = localVisualItem.getBounds();
      double d1 = localRectangle2D.getMinX() < paramRectangle2D.getMinX() ? localRectangle2D.getMinX() : paramRectangle2D.getMinX();
      double d2 = localRectangle2D.getMaxX() > paramRectangle2D.getMaxX() ? localRectangle2D.getMaxX() : paramRectangle2D.getMaxX();
      double d3 = localRectangle2D.getMinY() < paramRectangle2D.getMinY() ? localRectangle2D.getMinY() : paramRectangle2D.getMinY();
      double d4 = localRectangle2D.getMaxY() > paramRectangle2D.getMaxY() ? localRectangle2D.getMaxY() : paramRectangle2D.getMaxY();
      paramRectangle2D.setFrame(d1, d3, d2 - d1, d4 - d3);
    }
    paramRectangle2D.setFrame(paramRectangle2D.getMinX() - paramDouble, paramRectangle2D.getMinY() - paramDouble, paramRectangle2D.getWidth() + 2.0D * paramDouble, paramRectangle2D.getHeight() + 2.0D * paramDouble);
    return paramRectangle2D;
  }
  
  public static Rectangle2D getBounds(Iterator paramIterator, double paramDouble)
  {
    Rectangle2D.Double localDouble = new Rectangle2D.Double();
    return getBounds(paramIterator, paramDouble, localDouble);
  }
  
  public static Point2D getCentroid(Iterator paramIterator, Point2D paramPoint2D)
  {
    double d1 = 0.0D;
    double d2 = 0.0D;
    for (int i = 0; paramIterator.hasNext(); i++)
    {
      VisualItem localVisualItem = (VisualItem)paramIterator.next();
      double d3 = localVisualItem.getX();
      double d4 = localVisualItem.getY();
      if ((!Double.isInfinite(d3)) && (!Double.isNaN(d3)) && (!Double.isInfinite(d4)) && (!Double.isNaN(d4)))
      {
        d1 += d3;
        d2 += d4;
      }
    }
    if (i > 0)
    {
      d1 /= i;
      d2 /= i;
    }
    paramPoint2D.setLocation(d1, d2);
    return paramPoint2D;
  }
  
  public static Point2D getCentroid(Iterator paramIterator)
  {
    return getCentroid(paramIterator, new Point2D.Double());
  }
  
  public static void fitViewToBounds(Display paramDisplay, Rectangle2D paramRectangle2D, long paramLong)
  {
    fitViewToBounds(paramDisplay, paramRectangle2D, null, paramLong);
  }
  
  public static void fitViewToBounds(Display paramDisplay, Rectangle2D paramRectangle2D, Point2D paramPoint2D, long paramLong)
  {
    double d1 = paramDisplay.getWidth();
    double d2 = paramDisplay.getHeight();
    double d3 = paramPoint2D == null ? paramRectangle2D.getCenterX() : paramPoint2D.getX();
    double d4 = paramPoint2D == null ? paramRectangle2D.getCenterY() : paramPoint2D.getY();
    double d5 = Math.max(d3 - paramRectangle2D.getMinX(), paramRectangle2D.getMaxX() - d3);
    double d6 = Math.max(d4 - paramRectangle2D.getMinY(), paramRectangle2D.getMaxY() - d4);
    double d7 = Math.min(d1 / (2.0D * d5), d2 / (2.0D * d6)) / paramDisplay.getScale();
    if (paramPoint2D == null) {
      paramPoint2D = new Point2D.Double(d3, d4);
    }
    if (paramLong > 0L)
    {
      paramDisplay.animatePanAndZoomToAbs(paramPoint2D, d7, paramLong);
    }
    else
    {
      paramDisplay.panToAbs(paramPoint2D);
      paramDisplay.zoomAbs(paramPoint2D, d7);
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\display\DisplayLib.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */